

/*************************************************************************
*	File : complex.h						 *
*	Note : prototypes for complex operations.			 *
*************************************************************************/

typedef struct { double re; double im; } cmplx;

cmplx	complex ( double x, double y );			/*  x + jy	*/
cmplx	cmplx_add ( cmplx a, cmplx b );			/*  a + b	*/
cmplx	cmplx_sub ( cmplx a, cmplx b );			/*  a - b	*/
cmplx	cmplx_scl ( double x, cmplx a );		/*  xa		*/
cmplx	cmplx_mul ( cmplx a, cmplx b );			/*  ab		*/
cmplx	cmplx_div ( cmplx a, cmplx b );			/*  a/b		*/
cmplx	cmplx_add_mul ( cmplx a, cmplx b, cmplx c );	/*  a + bc	*/
cmplx	cmplx_sub_mul ( cmplx a, cmplx b, cmplx c );	/*  a - bc	*/
cmplx	cmplx_inv ( cmplx a );				/*   1/a	*/
double	abs_cmplx ( cmplx a );				/*   |a|	*/
double	pha_cmplx ( cmplx a );				/* phase angle  */
