/*******
*	File :	plot_lib.h
*	Note :	Definition of structures and prototypes.
********/

typedef struct{ double A, x; } area_function;

typedef struct{ int	n;			/* viewport number	*/
		double	x,			/* left-top position in	*/
			y,			/* logical units	*/
			w,			/* width and height	*/
			h;
		} vp_lo_frame;

void	af_read	(char *af_path, int *nss, area_function **af);
void	plot_af	(int ns, area_function *af);
void	plot_af_source_loc
		(char *title, int src_loc, int ns, area_function *af,
		 vp_lo_frame vp );
void	plot_signal
		(int n, double *t, double *s, vp_lo_frame vp);
void	plot_tf	(int np, double *f, double *tf, vp_lo_frame vp);
void	plot_FA	(int nfrms, double *frm, double *amp,
		 vp_lo_frame vp);
void	plot_FBA(int nfrms, double *frm, double *bw, double *amp,
		 vp_lo_frame vp);
void	plot_PUR (double Psub, double Udc, double Rg_v, double Rg_k,
		  double Rc_k, vp_lo_frame vp);
void	plot_glottal_area
		(int n, double tmin, double tmax,
		 double *t, double *s, vp_lo_frame vp );
void	plot_speech_signal
		(int n, double tmin, double tmax,
		 double *t, double *s, vp_lo_frame vp );
