/*---------------------------------------------------------------*/
#include "diva.h"
#include "diva_dir.h"
#include "../rbf_src/rbf.h"


#include <X11/Xlib.h>
#include <X11/Xutil.h>
/*  Header files for OSF/Motif toolkit */
#include <X11/Intrinsic.h> 
#include <X11/StringDefs.h>
#include <Xm/Xm.h>
/*  Include header file of each widget used */
#include <Xm/Form.h>
#include <Xm/PushB.h>
#include <Xm/Scale.h>
#include <Xm/DrawingA.h>
#include <Xm/FileSB.h>
#include <Xm/SelectioB.h>
#include <Xm/MessageB.h>
#include <Xm/RowColumn.h>
#include <Xm/Label.h>
#include <Xm/TextF.h>
#include <Xm/List.h>
#include <Xm/ToggleB.h>
#include <sys/stat.h>
char *savefilename;  /* has to be global to allow overwrite protection */

Widget F0_string;
Widget SF0_string;
Widget F1_value_string;
Widget F2_value_string;
Widget F3_value_string;
Widget F1_target_string;
Widget F2_target_string;
Widget F3_target_string;
Widget ratio1_value_string;
Widget ratio2_value_string;
Widget ratio3_value_string;
Widget ratio1_target_string;
Widget ratio2_target_string;
Widget ratio3_target_string;
Widget min_area_string;
Widget speak_string;

Widget jaw_height_scale;
Widget tongue_body_position_scale;
Widget tongue_body_shape_scale;
Widget tongue_tip_position_scale;
Widget lip_aperture_scale;
Widget lip_protrusion_scale;
Widget larynx_height_scale;
Widget translation_list;

int AMpar_int[7];


void display_formants( void );
void get_f0();
extern double get_min_area( void );
extern double get_parameter();
void update_maeda_sliders( void );
extern double get_SF0();


/*******************************************************************/
/*******************************************************************/
/**********************      main()    *****************************/
/*******************************************************************/
/*******************************************************************/

void init_diva_graphics(int argc, char **argv)
{
    Arg args[20];
    char val[20] = "";
    Cardinal argcount;
    int fg, bg;
    XGCValues xgcv;
    XColor color, unused;
    Colormap cmap;
    Widget label, param_form;
    XtAppContext app;

    extern void handle_expose();
    extern void mouse_button_press();
    extern void get_param_name();
    extern void param_value_activate();
    extern void make_control_panel();
    extern void make_maeda_panel();
    extern void make_parameter_panel();
    extern void make_translation_panel();

    /* Initialize toolkit and create the top-level widget */
/*
    top_level = XtVaAppInitialize(&app,"Diva",NULL,0,&argc,argv,NULL,NULL);
*/
    top_level = XtInitialize(argv[0], "Diva", NULL, 0, &argc, argv);

    /* get data for desired background color */
    XtVaGetValues(top_level, XmNcolormap, &cmap, NULL);
    XAllocNamedColor(XtDisplay(top_level), cmap, "gray", 
		     &color, &unused);
    bg_color = color.pixel;
    XAllocNamedColor(XtDisplay(top_level), cmap, "black", 
		     &color, &unused);
    theBlackPixel = color.pixel;
    XAllocNamedColor(XtDisplay(top_level), cmap, "white", 
		     &color, &unused);
    theWhitePixel = color.pixel;


    /*  Create the main form widget */
    argcount = 0;
    XtSetArg(args[argcount], XmNbackground, bg_color); argcount++;
    form = XtCreateManagedWidget("Form", xmFormWidgetClass, 
				 top_level, args, argcount);


    /*  Create the drawing area */
    argcount = 0;
    XtSetArg(args[argcount], XmNbackground, theWhitePixel); argcount++;
    XtSetArg(args[argcount], XmNforeground, theBlackPixel); argcount++;
    XtSetArg(args[argcount], XmNtopAttachment, XmATTACH_FORM); argcount++;
    /* XtSetArg(args[argcount], XmNtopOffset, 5); argcount++; */
    XtSetArg(args[argcount], XmNtopOffset, 10); argcount++;
    XtSetArg(args[argcount], XmNleftAttachment, XmATTACH_FORM); argcount++;
    XtSetArg(args[argcount], XmNleftOffset, 8); argcount++; 
    XtSetArg(args[argcount], XmNwidth, 500); argcount++;
    XtSetArg(args[argcount], XmNheight, 660); argcount++;
    drawing_area = XtCreateManagedWidget("Drawing_area", 
					 xmDrawingAreaWidgetClass, 
				 form, args, argcount);
    XtAddCallback(drawing_area, XmNexposeCallback, handle_expose, 0);
    XtAddEventHandler(drawing_area, ButtonPressMask, 
		      False, mouse_button_press, NULL);


    /* Create parameter selection box area */

    argcount = 0;
    XtSetArg(args[argcount], XmNleftAttachment, XmATTACH_FORM); argcount++;
    XtSetArg(args[argcount], XmNtopAttachment, XmATTACH_WIDGET); argcount++;
    XtSetArg(args[argcount], XmNtopWidget, drawing_area); argcount++;
    /* XtSetArg(args[argcount], XmNtopOffset, -5); argcount++; */
    XtSetArg(args[argcount], XmNbackground, bg_color); argcount++;
    XtSetArg(args[argcount], XmNborderColor, bg_color); argcount++;  
    XtSetArg(args[argcount], XmNwidth, 500); argcount++; 
    param_form = XtCreateManagedWidget("param_form", 
				       xmFormWidgetClass, 
				       form, args, argcount);
    XtManageChild(param_form);

    label = XtVaCreateManagedWidget("Parameter name:",
				    xmLabelWidgetClass, param_form,
				    XmNleftAttachment, XmATTACH_FORM,
				    XmNleftOffset, 10,
				    XmNtopAttachment, XmATTACH_FORM,
				    XmNtopOffset, 7,
				    XmNbackground, bg_color,
				    XmNborderColor, bg_color,
				    NULL);
    param_button = XtVaCreateManagedWidget("                           ",
					   xmPushButtonWidgetClass,
					   param_form,
					   XmNleftAttachment, XmATTACH_WIDGET,
					   XmNleftWidget, label,
					   XmNtopAttachment, XmATTACH_FORM,
					   XmNtopOffset, 3,
					   XmNbackground, bg_color,
					   XmNborderColor, bg_color,
					   NULL);
    XtAddCallback(param_button, XmNactivateCallback, 
		  get_param_name, NULL);
    label = XtVaCreateManagedWidget("Parameter value:",
				    xmLabelWidgetClass, param_form,
				    XmNleftAttachment, XmATTACH_WIDGET,
				    XmNleftWidget, param_button,
				    XmNleftOffset, 10,
				    XmNtopAttachment, XmATTACH_FORM,
				    XmNtopOffset, 7,
				    XmNbackground, bg_color,
				    XmNborderColor, bg_color,
				    NULL);

    param_value_string = XtVaCreateManagedWidget("param_value_string",
					   xmTextFieldWidgetClass, 
					   param_form,
					   XmNvalue, "",
					   XmNtopAttachment, XmATTACH_FORM,
					   XmNleftAttachment, XmATTACH_WIDGET,
					   XmNleftWidget, label,
                                           XmNbackground, bg_color,
					   XmNborderColor, bg_color,
					   NULL);

    XtAddCallback(param_value_string, XmNvalueChangedCallback, 
		  param_value_activate, NULL);
/*
   XtAddCallback(param_value_string, XmNactivateCallback, 
		  param_value_activate, NULL);
*/

    /*  Create control panel */

    make_control_panel();


    /*  Create control panel for setting maeda parameters */

    make_maeda_panel();


    /*  Create translation panel */

    make_translation_panel();

    /* Create the GC.  First retrieve the background and foreground */
    /* colors from the widget's resources.  */
    argcount = 0;
    XtSetArg(args[argcount], XmNforeground, &fg); argcount++;
    XtSetArg(args[argcount], XmNbackground, &bg); argcount++;
    XtGetValues(drawing_area, args, argcount);
    /* Now define the GC with these colors */
    xgcv.foreground = fg;
    xgcv.background = bg;
    theGC = XtGetGC(drawing_area, GCForeground | GCBackground, &xgcv);

    /* Realize the widgets */
    XtRealizeWidget(top_level);

    theWindow = XtWindow(drawing_area);
    theDisplay = XtDisplay(drawing_area);

    /*  Initialize diva stuff */
    init_diva();

    /* Start main event-handling loop */
    XtMainLoop();

}
    
/*******************************************************************/
/*******************************************************************/
/**********************  end  main()   *****************************/
/*******************************************************************/
/*******************************************************************/


void make_translation_panel(void)
{
  extern void get_phoneme_string();
  extern void get_list_selection();
  extern void fix_artic_0(), fix_artic_1(), fix_artic_2(),
              fix_artic_3(), fix_artic_4(), fix_artic_5(), fix_artic_6();
  Arg args[20];
  Cardinal argcount;
  int i, num_phonemes = NUM_PHONEMES;
  Widget label, translation_panel, translation_table, min_area_form, 
         perturbation_form, string_panel;
  Widget artic_0_toggle, artic_1_toggle, artic_2_toggle, artic_3_toggle,
         artic_4_toggle, artic_5_toggle, artic_6_toggle;
  XmStringTable str_list;

    argcount = 0;
    XtSetArg(args[argcount], XmNleftAttachment, XmATTACH_WIDGET); argcount++;
    XtSetArg(args[argcount], XmNleftWidget, maeda_panel); argcount++;
    XtSetArg(args[argcount], XmNbackground, bg_color); argcount++;
    XtSetArg(args[argcount], XmNborderColor, bg_color); argcount++;
    translation_panel = XtCreateWidget("Translation_panel", 
				       xmRowColumnWidgetClass, 
				       form, args, argcount);
    XtManageChild(translation_panel);

    /* Create speak string label and text widget */
    argcount = 0;
    XtSetArg(args[argcount], XmNbackground, bg_color); argcount++;
    string_panel = XtCreateWidget("string_panel", xmRowColumnWidgetClass, 
			translation_panel, args, argcount);
    XtManageChild(string_panel);
    label = XtVaCreateManagedWidget("Phoneme string:", 
					  xmLabelWidgetClass, string_panel,
					  XmNbackground, bg_color,
					  XmNborderColor, bg_color,
					  NULL);
    speak_string = XtVaCreateManagedWidget("Speak_string",
					   xmTextFieldWidgetClass, 
					   string_panel,
					   XmNvalue, PHONEME_STRING,
                                           XmNbackground, bg_color,
					   XmNborderColor, bg_color,
					   NULL);
    XtAddCallback(speak_string, XmNvalueChangedCallback, 
		  get_phoneme_string, NULL);

    /* make new panel just so borders look good. */
    argcount = 0;
    XtSetArg(args[argcount], XmNbackground, bg_color); argcount++;
    translation_table = XtCreateWidget("Translation_table", 
				       xmRowColumnWidgetClass, 
				       translation_panel, args, argcount);
    XtManageChild(translation_table);

    label = XtVaCreateManagedWidget("Translation Table", 
					  xmLabelWidgetClass, 
					  translation_table,
					  XmNalignment, XmALIGNMENT_CENTER,
					  XmNbackground, bg_color,
					  XmNborderColor, bg_color,
					  NULL);
  str_list = (XmStringTable)XtMalloc((num_phonemes + 3)* sizeof (XmString *));
  str_list[0 ] = XmStringCreateSimple("   SOUND        ASCII");
  str_list[1 ] = XmStringCreateSimple("'e' in 'eve':     E");
  str_list[2 ] = XmStringCreateSimple("'i' in 'it':      i");
  str_list[3 ] = XmStringCreateSimple("'e' in 'met':     e");
  str_list[4 ] = XmStringCreateSimple("'a' in 'at':      a");
  str_list[5 ] = XmStringCreateSimple("'a' in 'father':  C");
  str_list[6 ] = XmStringCreateSimple("'a' in 'all':     c");
  str_list[7 ] = XmStringCreateSimple("'oo' in 'foot':   o");
  str_list[8 ] = XmStringCreateSimple("'oo' in 'boot':   U");
  str_list[9 ] = XmStringCreateSimple("'u' in 'up':      u");
  str_list[10] = XmStringCreateSimple("'i' in 'bird':    I");
  str_list[11] = XmStringCreateSimple("'oo' in 'vous':    F");

#ifdef COMMENT
/* not used */
  str_list[3 ] = XmStringCreateSimple("'a' in 'hate':    A");
  str_list[8 ] = XmStringCreateSimple("'o' in 'obey':    O");

  str_list[11] = XmStringCreateSimple("'f' in 'for':     f *");
  str_list[12] = XmStringCreateSimple("'th' in 'thin':   T");
  str_list[13] = XmStringCreateSimple("'s' in 'see':     s");
  str_list[14] = XmStringCreateSimple("'sh' in 'she':    S");
  str_list[15] = XmStringCreateSimple("'h' in 'he':      h *");
  str_list[16] = XmStringCreateSimple("'v' in 'vote':    v *");
  str_list[17] = XmStringCreateSimple("'th' in 'then':   D");
  str_list[18] = XmStringCreateSimple("'z' in 'zoo':     z");
  str_list[19] = XmStringCreateSimple("'z' in 'azure':   Z");
  str_list[20] = XmStringCreateSimple("'p' in 'pay':     p");
  str_list[21] = XmStringCreateSimple("'t' in 'to':      t");
  str_list[22] = XmStringCreateSimple("'k' in 'key':     k");
  str_list[23] = XmStringCreateSimple("'b' in 'be':      b");
  str_list[24] = XmStringCreateSimple("'d' in 'day':     d");
  str_list[25] = XmStringCreateSimple("'g' in 'go':      g");
  str_list[26] = XmStringCreateSimple("'m' in 'me':      m");
  str_list[27] = XmStringCreateSimple("'n' in 'no':      n");
  str_list[28] = XmStringCreateSimple("'n' in 'sing':    N");
  str_list[29] = XmStringCreateSimple("'r' in 'read':    r");
  str_list[30] = XmStringCreateSimple("'l' in 'let':     l");
  str_list[31] = XmStringCreateSimple("'w' in 'we':      w *");
  str_list[32] = XmStringCreateSimple("'y' in 'you':     y *");
  str_list[33] = XmStringCreateSimple("");
  str_list[34] = XmStringCreateSimple("* = not used in DIVA");
#endif COMMENT

  translation_list = XtVaCreateManagedWidget("trans_table", 
				 xmListWidgetClass, 
				 translation_table,
				 XmNbackground, bg_color,
				 XmNselectionPolicy, XmSINGLE_SELECT,
				 XmNborderColor, bg_color,
				 XmNvisibleItemCount, (num_phonemes + 1),
				 XmNitemCount, (num_phonemes + 1),
				 XmNitems, str_list,
				 NULL);  
  XtAddCallback(translation_list, XmNsingleSelectionCallback,
		get_list_selection, NULL);

  /* make new panel just so borders look good. */

  min_area_form = XtVaCreateManagedWidget("min_area_form",
				    xmFormWidgetClass, translation_panel,
				    XmNbackground, bg_color,
				    NULL);


  label = XtVaCreateManagedWidget("Min Area:",
				  xmLabelWidgetClass, min_area_form,
				  XmNleftAttachment, XmATTACH_FORM,
				  XmNleftOffset, 13,
				  XmNtopAttachment, XmATTACH_FORM,
				  XmNtopOffset, 5,
				  XmNbackground, bg_color,
				  XmNborderColor, bg_color,
				  NULL);
  
  min_area_string = XtVaCreateManagedWidget("min_area_string",
					    xmTextFieldWidgetClass,
					    min_area_form,
					    XmNcolumns, 6,
					    XmNvalue, "",
					    XmNtopAttachment, XmATTACH_FORM,
					    XmNleftAttachment, XmATTACH_WIDGET,
					    XmNleftWidget, label,
					    XmNcursorPositionVisible, False,
					    XmNbackground, bg_color,
					    XmNborderColor, bg_color,
					    NULL);
  
    label = XtVaCreateManagedWidget("F0:",
				    xmLabelWidgetClass, min_area_form,
				    XmNleftAttachment, XmATTACH_FORM,
				    XmNleftOffset, 49,
				    XmNtopAttachment, XmATTACH_WIDGET,
				    XmNtopWidget, min_area_string,
				    XmNtopOffset, 5,
				    XmNbackground, bg_color,
				    XmNborderColor, bg_color,
				    NULL);
  
    F0_string = XtVaCreateManagedWidget("F0_value_string",
				xmTextFieldWidgetClass,
				min_area_form,
				XmNcolumns, 6,
				XmNvalue, "",
				XmNtopAttachment, XmATTACH_WIDGET,
				XmNtopWidget, min_area_string,
				XmNleftAttachment, XmATTACH_WIDGET,
				XmNleftWidget, label,
				XmNbackground, bg_color,
				XmNborderColor, bg_color,
				NULL);
    XtAddCallback(F0_string, XmNvalueChangedCallback, 
		  get_f0, NULL);

    label = XtVaCreateManagedWidget("SF0:",
				    xmLabelWidgetClass, min_area_form,
				    XmNleftAttachment, XmATTACH_FORM,
				    XmNleftOffset, 44,
				    XmNtopAttachment, XmATTACH_WIDGET,
				    XmNtopWidget, F0_string,
				    XmNtopOffset, 5,
				    XmNbackground, bg_color,
				    XmNborderColor, bg_color,
				    NULL);
  
    SF0_string = XtVaCreateManagedWidget("SF0_value_string",
				xmTextFieldWidgetClass,
				min_area_form,
				XmNcolumns, 6,
				XmNvalue, "",
				XmNtopAttachment, XmATTACH_WIDGET,
				XmNtopWidget, F0_string,
				XmNleftAttachment, XmATTACH_WIDGET,
				XmNleftWidget, label,
				XmNbackground, bg_color,
				XmNborderColor, bg_color,
				NULL);


  perturbation_form = XtVaCreateManagedWidget("perturbation_form",
				    xmFormWidgetClass, translation_panel,
				    XmNbackground, bg_color,
				    NULL);

  label = XtVaCreateManagedWidget("Blocked articulators:",
				  xmLabelWidgetClass, perturbation_form,
				  XmNleftAttachment, XmATTACH_FORM,
				  XmNtopAttachment, XmATTACH_FORM,
				  XmNtopOffset, 5,
				  XmNbackground, bg_color,
				  XmNborderColor, bg_color,
				  NULL);

  artic_0_toggle = XtVaCreateManagedWidget("Jaw height",
					   xmToggleButtonWidgetClass,
					   perturbation_form,
					   XmNleftAttachment, XmATTACH_FORM,
					   XmNtopAttachment, XmATTACH_WIDGET,
					   XmNtopWidget, label,
					   XmNbackground, bg_color,
					   XmNborderColor, bg_color,
					   NULL);
  XtAddCallback(artic_0_toggle, XmNvalueChangedCallback, fix_artic_0, NULL);

  artic_1_toggle = XtVaCreateManagedWidget("Tongue body position",
					   xmToggleButtonWidgetClass,
					   perturbation_form,
					   XmNleftAttachment, XmATTACH_FORM,
					   XmNtopAttachment, XmATTACH_WIDGET,
					   XmNtopWidget, artic_0_toggle,
					   XmNbackground, bg_color,
					   XmNborderColor, bg_color,
					   NULL);
  XtAddCallback(artic_1_toggle, XmNvalueChangedCallback, fix_artic_1, NULL);

  artic_2_toggle = XtVaCreateManagedWidget("Tongue body shape",
					   xmToggleButtonWidgetClass,
					   perturbation_form,
					   XmNleftAttachment, XmATTACH_FORM,
					   XmNtopAttachment, XmATTACH_WIDGET,
					   XmNtopWidget, artic_1_toggle,
					   XmNbackground, bg_color,
					   XmNborderColor, bg_color,
					   NULL);
  XtAddCallback(artic_2_toggle, XmNvalueChangedCallback, fix_artic_2, NULL);

  artic_3_toggle = XtVaCreateManagedWidget("Tongue tip position",
					   xmToggleButtonWidgetClass,
					   perturbation_form,
					   XmNleftAttachment, XmATTACH_FORM,
					   XmNtopAttachment, XmATTACH_WIDGET,
					   XmNtopWidget, artic_2_toggle,
					   XmNbackground, bg_color,
					   XmNborderColor, bg_color,
					   NULL);
  XtAddCallback(artic_3_toggle, XmNvalueChangedCallback, fix_artic_3, NULL);

  artic_4_toggle = XtVaCreateManagedWidget("Lip aperture",
					   xmToggleButtonWidgetClass,
					   perturbation_form,
					   XmNleftAttachment, XmATTACH_FORM,
					   XmNtopAttachment, XmATTACH_WIDGET,
					   XmNtopWidget, artic_3_toggle,
					   XmNbackground, bg_color,
					   XmNborderColor, bg_color,
					   NULL);
  XtAddCallback(artic_4_toggle, XmNvalueChangedCallback, fix_artic_4, NULL);

  artic_5_toggle = XtVaCreateManagedWidget("Lip protrusion",
					   xmToggleButtonWidgetClass,
					   perturbation_form,
					   XmNleftAttachment, XmATTACH_FORM,
					   XmNtopAttachment, XmATTACH_WIDGET,
					   XmNtopWidget, artic_4_toggle,
					   XmNbackground, bg_color,
					   XmNborderColor, bg_color,
					   NULL);
  XtAddCallback(artic_5_toggle, XmNvalueChangedCallback, fix_artic_5, NULL);

  artic_6_toggle = XtVaCreateManagedWidget("Larynx height",
					   xmToggleButtonWidgetClass,
					   perturbation_form,
					   XmNleftAttachment, XmATTACH_FORM,
					   XmNtopAttachment, XmATTACH_WIDGET,
					   XmNtopWidget, artic_5_toggle,
					   XmNbackground, bg_color,
					   XmNborderColor, bg_color,
					   NULL);
  XtAddCallback(artic_6_toggle, XmNvalueChangedCallback, fix_artic_6, NULL);
}


void make_maeda_panel(void)
{
    int i;
    Arg args[20];
    Cardinal argcount;
    Widget label;

    Widget formant_form, ratio_form;

    extern void change_jaw_height();
    extern void change_tongue_body_position();
    extern void change_tongue_body_shape();
    extern void change_tongue_tip_position();
    extern void change_lip_aperture();
    extern void change_lip_protrusion();
    extern void change_larynx_height();
    extern void get_f1_target();
    extern void get_f2_target();
    extern void get_f3_target();
    extern void get_ratio1_target();
    extern void get_ratio2_target();
    extern void get_ratio3_target();

    /* make maeda panel RowColumn Widget */
    argcount = 0;
    XtSetArg(args[argcount], XmNleftAttachment, XmATTACH_WIDGET); argcount++;
    /* XtSetArg(args[argcount], XmNleftOffset, 4); argcount++; */
    XtSetArg(args[argcount], XmNleftWidget, control_panel); argcount++;
    XtSetArg(args[argcount], XmNbackground, bg_color); argcount++;
    XtSetArg(args[argcount], XmNborderColor, bg_color); argcount++;
    maeda_panel = XtCreateWidget("maeda_panel", xmRowColumnWidgetClass, 
			form, args, argcount);
    XtManageChild(maeda_panel);

    for (i=0; i<7; i++)
	AMpar_int[i] = (int)(100*AMpar[i]);

    /* Create jaw height slider */
    jaw_height_scale = XtVaCreateManagedWidget("JawHeight",
					  xmScaleWidgetClass,
					  maeda_panel,
					  XmNbackground, bg_color,
				  XtVaTypedArg, XmNtitleString,
				  XmRString, "Jaw Height", 11,
				  XmNscaleWidth, 250,
				  XmNmaximum, 300,
				  XmNminimum, -300,
				  XmNorientation, XmHORIZONTAL,
				  XmNdecimalPoints, 2, 
				  XmNvalue, AMpar_int[0],
				  XmNshowValue, True,
				  NULL);
    XtAddCallback(jaw_height_scale, 
		  XmNdragCallback, change_jaw_height, NULL);

    /* Create tongue body position slider */
    tongue_body_position_scale = XtVaCreateManagedWidget("TongueBodyPosition",
					  xmScaleWidgetClass,
					  maeda_panel,
					  XmNbackground, bg_color,
				  XtVaTypedArg, XmNtitleString,
				  XmRString, "Tongue Body Position", 21,
				  XmNscaleWidth, 250,
				  XmNmaximum, 300,
				  XmNminimum, -300,
				  XmNorientation, XmHORIZONTAL,
				  XmNdecimalPoints, 2, 
				  XmNvalue, AMpar_int[1],
				  XmNshowValue, True,
				  NULL);
    XtAddCallback(tongue_body_position_scale, 
		  XmNdragCallback, change_tongue_body_position, NULL);

    /* Create tongue body shape slider */
    tongue_body_shape_scale = XtVaCreateManagedWidget("TongueBodyShape",
					  xmScaleWidgetClass,
					  maeda_panel,
					  XmNbackground, bg_color,
				  XtVaTypedArg, XmNtitleString,
				  XmRString, "Tongue Body Shape", 18,
				  XmNscaleWidth, 250,
				  XmNmaximum, 300,
				  XmNminimum, -300,
				  XmNorientation, XmHORIZONTAL,
				  XmNdecimalPoints, 2, 
				  XmNvalue, AMpar_int[2],
				  XmNshowValue, True,
				  NULL);
    XtAddCallback(tongue_body_shape_scale, 
		  XmNdragCallback, change_tongue_body_shape, NULL);

    /* Create tongue tip position slider */
    tongue_tip_position_scale = XtVaCreateManagedWidget("TongueTipPosition",
					  xmScaleWidgetClass,
					  maeda_panel,
					  XmNbackground, bg_color,
				  XtVaTypedArg, XmNtitleString,
				  XmRString, "Tongue Tip Position", 20,
				  XmNscaleWidth, 250,
				  XmNmaximum, 300,
				  XmNminimum, -300,
				  XmNorientation, XmHORIZONTAL,
				  XmNdecimalPoints, 2, 
				  XmNvalue, AMpar_int[3],
				  XmNshowValue, True,
				  NULL);
    XtAddCallback(tongue_tip_position_scale, 
		  XmNdragCallback, change_tongue_tip_position, NULL);

    /* Create lip aperture slider */
    lip_aperture_scale = XtVaCreateManagedWidget("LipAperture",
					  xmScaleWidgetClass,
					  maeda_panel,
					  XmNbackground, bg_color,
				  XtVaTypedArg, XmNtitleString,
				  XmRString, "Lip Aperture", 13,
				  XmNscaleWidth, 250,
				  XmNmaximum, 300,
				  XmNminimum, -300,
				  XmNorientation, XmHORIZONTAL,
				  XmNdecimalPoints, 2, 
				  XmNvalue, AMpar_int[4],
				  XmNshowValue, True,
				  NULL);
    XtAddCallback(lip_aperture_scale, 
		  XmNdragCallback, change_lip_aperture, NULL);

    /* Create lip protrusion slider */
    lip_protrusion_scale = XtVaCreateManagedWidget("LipProtrusion",
					  xmScaleWidgetClass,
					  maeda_panel,
					  XmNbackground, bg_color,
				  XtVaTypedArg, XmNtitleString,
				  XmRString, "Lip Protrusion", 15,
				  XmNscaleWidth, 250,
				  XmNmaximum, 300,
				  XmNminimum, -300,
				  XmNorientation, XmHORIZONTAL,
				  XmNdecimalPoints, 2, 
				  XmNvalue, AMpar_int[5],
				  XmNshowValue, True,
				  NULL);
    XtAddCallback(lip_protrusion_scale, 
		  XmNdragCallback, change_lip_protrusion, NULL);

    /* Create larynx height slider */
    larynx_height_scale = XtVaCreateManagedWidget("LarynxHeight",
					  xmScaleWidgetClass,
					  maeda_panel,
					  XmNbackground, bg_color,
				  XtVaTypedArg, XmNtitleString,
				  XmRString, "Larynx Height", 14,
				  XmNscaleWidth, 250,
				  XmNmaximum, 300,
				  XmNminimum, -300,
				  XmNorientation, XmHORIZONTAL,
				  XmNdecimalPoints, 2, 
				  XmNvalue, AMpar_int[6],
				  XmNshowValue, True,
				  NULL);
    XtAddCallback(larynx_height_scale, 
		  XmNdragCallback, change_larynx_height, NULL);

    /*
     * Create form widgets to occupy next vertical positions in maeda panel
     * but which allow horizontal placement of label and value for formants.
     */
    

    formant_form = XtVaCreateManagedWidget("formant_form",
				    xmFormWidgetClass, maeda_panel,
				    XmNbackground, bg_color,
				    NULL);

    /*
     * Now create the label and String Widgets that will occupy the 
     * f*_form Widgets.
     */


    label = XtVaCreateManagedWidget("F1:",
				    xmLabelWidgetClass, formant_form,
				    XmNleftAttachment, XmATTACH_FORM,
				    XmNleftOffset, 42,
				    XmNtopAttachment, XmATTACH_FORM,
				    XmNtopOffset, 5,
				    XmNbackground, bg_color,
				    XmNborderColor, bg_color,
				    NULL);

    F1_value_string = XtVaCreateManagedWidget("F1_value_string",
				xmTextFieldWidgetClass,
				formant_form,
				XmNcolumns, 5,
				XmNvalue, "",
				XmNtopAttachment, XmATTACH_FORM,
				XmNleftAttachment, XmATTACH_WIDGET,
				XmNleftWidget, label,
				XmNcursorPositionVisible, False,
				XmNbackground, bg_color,
				XmNborderColor, bg_color,
				NULL);

    label = XtVaCreateManagedWidget("Target:",
				    xmLabelWidgetClass, formant_form,
				    XmNleftAttachment, XmATTACH_FORM,
				    XmNleftOffset, 130,
				    XmNtopAttachment, XmATTACH_FORM,
				    XmNtopOffset, 5,
				    XmNbackground, bg_color,
				    XmNborderColor, bg_color,
				    NULL);

    F1_target_string = XtVaCreateManagedWidget("F1_target_string",
				xmTextFieldWidgetClass,
				formant_form,
				XmNcolumns, 5,
				XmNvalue, "",
				XmNtopAttachment, XmATTACH_FORM,
				XmNleftAttachment, XmATTACH_WIDGET,
				XmNleftWidget, label,
				XmNbackground, bg_color,
				XmNborderColor, bg_color,
				NULL);
    XtAddCallback(F1_target_string, XmNvalueChangedCallback, 
		  get_f1_target, NULL);

    label = XtVaCreateManagedWidget("F2:",
				    xmLabelWidgetClass, formant_form,
				    XmNleftAttachment, XmATTACH_FORM,
				    XmNleftOffset, 42,
				    XmNtopAttachment, XmATTACH_WIDGET,
				    XmNtopWidget, F1_target_string,
				    XmNtopOffset, 5,
				    XmNbackground, bg_color,
				    XmNborderColor, bg_color,
				    NULL);

    F2_value_string = XtVaCreateManagedWidget("F2_value_string",
				xmTextFieldWidgetClass, 
				formant_form,
				XmNcolumns, 5,
				XmNvalue, "",
				XmNtopAttachment, XmATTACH_WIDGET,
				XmNtopWidget, F1_target_string,
				XmNleftAttachment, XmATTACH_WIDGET,
				XmNleftWidget, label,
				XmNcursorPositionVisible, False,
				XmNbackground, bg_color,
				XmNborderColor, bg_color,
				NULL);

    label = XtVaCreateManagedWidget("Target:",
				    xmLabelWidgetClass, formant_form,
				    XmNleftAttachment, XmATTACH_FORM,
				    XmNleftOffset, 130,
				    XmNtopAttachment, XmATTACH_WIDGET,
				    XmNtopWidget, F1_target_string,
				    XmNtopOffset, 5,
				    XmNbackground, bg_color,
				    XmNborderColor, bg_color,
				    NULL);

    F2_target_string = XtVaCreateManagedWidget("F2_target_string",
				xmTextFieldWidgetClass, 
			        formant_form,
				XmNcolumns, 5,
				XmNvalue, "",
				XmNtopAttachment, XmATTACH_WIDGET,
				XmNtopWidget, F1_target_string,
				XmNleftAttachment, XmATTACH_WIDGET,
				XmNleftWidget, label,
				XmNbackground, bg_color,
				XmNborderColor, bg_color,
				NULL);
    XtAddCallback(F2_target_string, XmNvalueChangedCallback, 
		  get_f2_target, NULL);


    label = XtVaCreateManagedWidget("F3:",
				    xmLabelWidgetClass, formant_form,
				    XmNleftAttachment, XmATTACH_FORM,
				    XmNleftOffset, 42,
				    XmNtopAttachment, XmATTACH_WIDGET,
				    XmNtopWidget, F2_target_string,
				    XmNtopOffset, 5,
				    XmNbackground, bg_color,
				    XmNborderColor, bg_color,
				    NULL);
    F3_value_string = XtVaCreateManagedWidget("F3_value_string",
				xmTextFieldWidgetClass, 
				formant_form,
				XmNcolumns, 5,
				XmNvalue, "",
				XmNtopAttachment, XmATTACH_WIDGET,
			        XmNtopWidget, F2_target_string,
				XmNleftAttachment, XmATTACH_WIDGET,
				XmNleftWidget, label,
				XmNcursorPositionVisible, False,
				XmNbackground, bg_color,
				XmNborderColor, bg_color,
				NULL);

    label = XtVaCreateManagedWidget("Target:",
				    xmLabelWidgetClass, formant_form,
				    XmNleftAttachment, XmATTACH_FORM,
				    XmNleftOffset, 130,
				    XmNtopAttachment, XmATTACH_WIDGET,
			            XmNtopWidget, F2_target_string,
				    XmNtopOffset, 5,
				    XmNbackground, bg_color,
				    XmNborderColor, bg_color,
				    NULL);
    F3_target_string = XtVaCreateManagedWidget("F3_target_string",
				xmTextFieldWidgetClass, 
				formant_form,
				XmNcolumns, 5,
				XmNvalue, "",
				XmNtopAttachment, XmATTACH_WIDGET,
			        XmNtopWidget, F2_target_string,
				XmNleftAttachment, XmATTACH_WIDGET,
				XmNleftWidget, label,
				XmNbackground, bg_color,
				XmNborderColor, bg_color,
				NULL);
    XtAddCallback(F3_target_string, XmNvalueChangedCallback, 
		  get_f3_target, NULL);


    /*
     * Create form widget to occupy next vertical position in maeda panel
     * but which allows horizontal placement of label and value for ratios.
     */
    

    ratio_form = XtVaCreateManagedWidget("ratio_form",
				    xmFormWidgetClass, maeda_panel,
				    XmNbackground, bg_color,
				    NULL);

    /*
     * Now create the label and String Widgets that will occupy the 
     * ratio_form Widget.
     */


    label = XtVaCreateManagedWidget("logF1/SF0:",
				    xmLabelWidgetClass, ratio_form,
				    XmNleftAttachment, XmATTACH_FORM,
				    XmNleftOffset, 0,
				    XmNtopAttachment, XmATTACH_FORM,
				    XmNtopOffset, 5,
				    XmNbackground, bg_color,
				    XmNborderColor, bg_color,
				    NULL);

    ratio1_value_string = XtVaCreateManagedWidget("ratio1_value_string",
				xmTextFieldWidgetClass,
				ratio_form,
				XmNcolumns, 5,
				XmNvalue, "",
				XmNtopAttachment, XmATTACH_FORM,
				XmNleftAttachment, XmATTACH_WIDGET,
				XmNleftWidget, label,
				XmNcursorPositionVisible, False,
				XmNbackground, bg_color,
				XmNborderColor, bg_color,
				NULL);

    label = XtVaCreateManagedWidget("Target:",
				    xmLabelWidgetClass, ratio_form,
				    XmNleftAttachment, XmATTACH_FORM,
				    XmNleftOffset, 130,
				    XmNtopAttachment, XmATTACH_FORM,
				    XmNtopOffset, 5,
				    XmNbackground, bg_color,
				    XmNborderColor, bg_color,
				    NULL);

    ratio1_target_string = XtVaCreateManagedWidget("ratio1_target_string",
				xmTextFieldWidgetClass,
				ratio_form,
				XmNcolumns, 5,
				XmNvalue, "",
				XmNtopAttachment, XmATTACH_FORM,
				XmNleftAttachment, XmATTACH_WIDGET,
				XmNleftWidget, label,
				XmNbackground, bg_color,
				XmNborderColor, bg_color,
				NULL);
    XtAddCallback(ratio1_target_string, XmNvalueChangedCallback, 
		  get_ratio1_target, NULL);

    label = XtVaCreateManagedWidget("logF2/F1:",
				    xmLabelWidgetClass, ratio_form,
				    XmNleftAttachment, XmATTACH_FORM,
				    XmNleftOffset, 6,
				    XmNtopAttachment, XmATTACH_WIDGET,
				    XmNtopWidget, ratio1_target_string,
				    XmNtopOffset, 5,
				    XmNbackground, bg_color,
				    XmNborderColor, bg_color,
				    NULL);

    ratio2_value_string = XtVaCreateManagedWidget("ratio2_value_string",
				xmTextFieldWidgetClass, 
				ratio_form,
				XmNcolumns, 5,
				XmNvalue, "",
				XmNtopAttachment, XmATTACH_WIDGET,
				XmNtopWidget, ratio1_target_string,
				XmNleftAttachment, XmATTACH_WIDGET,
				XmNleftWidget, label,
				XmNcursorPositionVisible, False,
				XmNbackground, bg_color,
				XmNborderColor, bg_color,
				NULL);

    label = XtVaCreateManagedWidget("Target:",
				    xmLabelWidgetClass, ratio_form,
				    XmNleftAttachment, XmATTACH_FORM,
				    XmNleftOffset, 130,
				    XmNtopAttachment, XmATTACH_WIDGET,
				    XmNtopWidget, ratio1_target_string,
				    XmNtopOffset, 5,
				    XmNbackground, bg_color,
				    XmNborderColor, bg_color,
				    NULL);

    ratio2_target_string = XtVaCreateManagedWidget("ratio2_target_string",
				xmTextFieldWidgetClass, 
			        ratio_form,
				XmNcolumns, 5,
				XmNvalue, "",
				XmNtopAttachment, XmATTACH_WIDGET,
				XmNtopWidget, ratio1_target_string,
				XmNleftAttachment, XmATTACH_WIDGET,
				XmNleftWidget, label,
				XmNbackground, bg_color,
				XmNborderColor, bg_color,
				NULL);
    XtAddCallback(ratio2_target_string, XmNvalueChangedCallback, 
		  get_ratio2_target, NULL);

    label = XtVaCreateManagedWidget("logF3/F2:",
				    xmLabelWidgetClass, ratio_form,
				    XmNleftAttachment, XmATTACH_FORM,
				    XmNleftOffset, 6,
				    XmNtopAttachment, XmATTACH_WIDGET,
				    XmNtopWidget, ratio2_target_string,
				    XmNtopOffset, 5,
				    XmNbackground, bg_color,
				    XmNborderColor, bg_color,
				    NULL);
    ratio3_value_string = XtVaCreateManagedWidget("ratio3_value_string",
				xmTextFieldWidgetClass, 
				ratio_form,
				XmNcolumns, 5,
				XmNvalue, "",
				XmNtopAttachment, XmATTACH_WIDGET,
			        XmNtopWidget, ratio2_target_string,
				XmNleftAttachment, XmATTACH_WIDGET,
				XmNleftWidget, label,
				XmNcursorPositionVisible, False,
				XmNbackground, bg_color,
				XmNborderColor, bg_color,
				NULL);

    label = XtVaCreateManagedWidget("Target:",
				    xmLabelWidgetClass, ratio_form,
				    XmNleftAttachment, XmATTACH_FORM,
				    XmNleftOffset, 130,
				    XmNtopAttachment, XmATTACH_WIDGET,
			            XmNtopWidget, ratio2_target_string,
				    XmNtopOffset, 5,
				    XmNbackground, bg_color,
				    XmNborderColor, bg_color,
				    NULL);
    ratio3_target_string = XtVaCreateManagedWidget("ratio3_target_string",
				xmTextFieldWidgetClass, 
				ratio_form,
				XmNcolumns, 5,
				XmNvalue, "",
				XmNtopAttachment, XmATTACH_WIDGET,
			        XmNtopWidget, ratio2_target_string,
				XmNleftAttachment, XmATTACH_WIDGET,
				XmNleftWidget, label,
				XmNbackground, bg_color,
				XmNborderColor, bg_color,
				NULL);
    XtAddCallback(ratio3_target_string, XmNvalueChangedCallback, 
		  get_ratio3_target, NULL);
}

void make_control_panel(void)
{
  Arg args[20];
  Cardinal argcount;
  Widget volume_scale,
  animation_speed_scale, speaking_rate_scale, label, 
  babble_panel, babble_type_box, 
  perturb_panel, perturb_type_box, button,
  button_panel;

    extern void speak();
    void goto_formant_target();
    void goto_ratio_target();
    extern void babble();
    extern void setbreak();
    extern void resetconfig();
    extern void printconfig();
    extern void setcontinue();
    extern void setpause();
    extern void synthbutton();
    extern void setfixedjaw();
    extern void setcoordframe();
    extern void setfixedf0();
    extern void quit();
    extern void load_weight_file_popup();
    extern void save_weight_file_popup();
    extern void load_parameter_file_popup();
    extern void plot_config_file_popup();
    extern void play_demo_popup();
    extern void make_demo_popup();
    extern void save_parameter_file_popup();
    extern void change_parameters_popup();
    extern void change_speed();
    extern void change_speaking_rate();
    extern void no_pert();
    extern void lip_pert();
    extern void jaw_pert();
    extern void fix_jaw();
    extern void set_random();
    extern void set_variegated();

    extern void update_speak_string();
    extern void update_F1_target();
    extern void update_F2_target();
    extern void update_F3_target();
    extern void update_ratio1_target();
    extern void update_ratio2_target();
    extern void update_ratio3_target();

    /* make main control panel RowColumn Widget */
    argcount = 0;
    XtSetArg(args[argcount], XmNleftAttachment, XmATTACH_WIDGET); argcount++;
    /* XtSetArg(args[argcount], XmNleftOffset, 4); argcount++; */
    XtSetArg(args[argcount], XmNleftWidget, drawing_area); argcount++;
    XtSetArg(args[argcount], XmNbackground, bg_color); argcount++;
    XtSetArg(args[argcount], XmNborderColor, bg_color); argcount++;
    control_panel = XtCreateWidget("control_panel", xmRowColumnWidgetClass, 
			form, args, argcount);
    XtManageChild(control_panel);



#ifdef COMMENT
    /* Create animation speed slider */
    animation_speed_scale = XtVaCreateManagedWidget("Speed",
					  xmScaleWidgetClass,
					  control_panel,
					  XmNbackground, bg_color,
				  XtVaTypedArg, XmNtitleString,
				  XmRString, "Animation Speed", 16,
				  XmNmaximum, 100,
				  XmNminimum, 0,
				  XmNdecimalPoints, 2, 
				  XmNorientation, XmHORIZONTAL,
				  XmNvalue, ANIMATION_SPEED,
				  XmNshowValue, True,
				  NULL);
    XtAddCallback(animation_speed_scale, 
		  XmNvalueChangedCallback, change_speed, NULL);
#endif COMMENT

    /* Create speaking rate slider */
    speaking_rate_scale = XtVaCreateManagedWidget("SpeakingRate", 
						  xmScaleWidgetClass,
						  control_panel,
						  XmNbackground, bg_color,
				  XtVaTypedArg, XmNtitleString,
				  XmRString, "Speaking Rate", 14,
				  XmNmaximum, 100,
				  XmNminimum, 0,
				  XmNdecimalPoints, 2, 
				  XmNorientation, XmHORIZONTAL,
				  XmNvalue, SPEAKING_RATE,
				  XmNshowValue, True,
				  NULL);
    XtAddCallback(speaking_rate_scale, XmNvalueChangedCallback, 
		  change_speaking_rate, NULL);


#ifdef COMMENT
    /* volume slider */
    volume_scale = XtVaCreateManagedWidget("Volume", 
						  xmScaleWidgetClass,
						  control_panel,
						  XmNbackground, bg_color,
				  XtVaTypedArg, XmNtitleString,
				  XmRString, "Volume", 7,
				  XmNmaximum, 100,
				  XmNminimum, 0,
				  XmNdecimalPoints, 2, 
				  XmNorientation, XmHORIZONTAL,
				  XmNvalue, SPEAKING_RATE,
				  XmNshowValue, True,
				  NULL);
    XtAddCallback(volume_scale, XmNvalueChangedCallback, 
		  change_volume, NULL);
#endif COMMENT


#ifdef COMMENT
    /* Create babble type radio box */
    argcount = 0;
    XtSetArg(args[argcount], XmNbackground, bg_color); argcount++;
    babble_panel = XtCreateWidget("babble_panel", xmRowColumnWidgetClass, 
			control_panel, args, argcount);
    XtManageChild(babble_panel);
    label = XtVaCreateManagedWidget("Type of babbling:", 
				    xmLabelWidgetClass, babble_panel,
				    XmNbackground, bg_color,
				    XmNborderColor, bg_color,
				    NULL);
    argcount = 0;
    XtSetArg(args[argcount], XmNbackground, bg_color); argcount++;
    XtSetArg(args[argcount], XmNborderColor, bg_color); argcount++;
    babble_type_box = XmCreateRadioBox(babble_panel, "Babble_radio_box",
				       args, argcount);
    XtManageChild(babble_type_box);
    button = XtVaCreateManagedWidget("Random",
				     xmToggleButtonWidgetClass,
				     babble_type_box,
				     XmNbackground, bg_color,
				     XmNborderColor, bg_color,
				     NULL);
    XtAddCallback(button, XmNvalueChangedCallback, set_random, NULL);
    button = XtVaCreateManagedWidget("Variegated",
					 xmToggleButtonWidgetClass,
					 babble_type_box,
					 XmNbackground, bg_color,
					 XmNborderColor, bg_color,
					 NULL);
    XtAddCallback(button, XmNvalueChangedCallback, 
		  set_variegated, NULL);


    /* Create perturbation type radio box */
    argcount = 0;
    XtSetArg(args[argcount], XmNbackground, bg_color); argcount++;
    perturb_panel = XtCreateWidget("perturb_panel", xmRowColumnWidgetClass, 
			control_panel, args, argcount);
    XtManageChild(perturb_panel);
    label = XtVaCreateManagedWidget("Type of perturbation:", 
				    xmLabelWidgetClass, perturb_panel,
				    XmNbackground, bg_color,
				    XmNborderColor, bg_color,
				    NULL);
    argcount = 0;
    XtSetArg(args[argcount], XmNbackground, bg_color); argcount++;
    XtSetArg(args[argcount], XmNborderColor, bg_color); argcount++;
    perturb_type_box = XmCreateRadioBox(perturb_panel, "perturb_radio_box",
				       args, argcount);
    XtManageChild(perturb_type_box);
    button = XtVaCreateManagedWidget("No perturbation",
				     xmToggleButtonWidgetClass,
				     perturb_type_box,
				     XmNbackground, bg_color,
				     XmNborderColor, bg_color,
				     NULL);
    XtAddCallback(button, XmNvalueChangedCallback, no_pert, NULL);
    button = XtVaCreateManagedWidget("Lip perturbation",
					    xmToggleButtonWidgetClass,
					    perturb_type_box,
					    XmNbackground, bg_color,
					    XmNborderColor, bg_color,
					    NULL);
    XtAddCallback(button, XmNvalueChangedCallback, 
		  lip_pert, NULL);
    button = XtVaCreateManagedWidget("Jaw perturbation",
					 xmToggleButtonWidgetClass,
					 perturb_type_box,
					 XmNbackground, bg_color,
					 XmNborderColor, bg_color,
					 NULL);
    XtAddCallback(button, XmNvalueChangedCallback, 
		  jaw_pert, NULL);
    button = XtVaCreateManagedWidget("Fixed jaw",
					 xmToggleButtonWidgetClass,
					 perturb_type_box,
					 XmNbackground, bg_color,
					 XmNborderColor, bg_color,
					 NULL);
    XtAddCallback(button, XmNvalueChangedCallback, 
		  fix_jaw, NULL);
#endif COMMENT


    /* Create button panel */
    argcount = 0;
    XtSetArg(args[argcount], XmNleftAttachment, XmATTACH_WIDGET); argcount++;
    XtSetArg(args[argcount], XmNleftWidget, drawing_area); argcount++;
    XtSetArg(args[argcount], XmNbackground, bg_color); argcount++;
    button_panel = XtCreateWidget("button_panel", xmRowColumnWidgetClass, 
			control_panel, args, argcount);
    XtManageChild(button_panel);

    /*  Create speak button */
    speak_button = XtVaCreateManagedWidget("Speak",
					   xmPushButtonWidgetClass,
					   button_panel,
					   XmNleftAttachment, XmATTACH_WIDGET,
					   XmNleftWidget, drawing_area,
					   XmNbackground, bg_color,
					   XmNborderColor, bg_color,
					   NULL);
    XtAddCallback(speak_button, XmNactivateCallback, speak, 0);

    /*  Create Goto formant target button */
    formant_button = XtVaCreateManagedWidget("Go to formant target",
					   xmPushButtonWidgetClass,
					   button_panel,
					   XmNleftAttachment, XmATTACH_WIDGET,
					   XmNleftWidget, drawing_area,
					   XmNtopAttachment, XmATTACH_WIDGET,
					   XmNtopWidget, speak_button,
					   XmNbackground, bg_color,
					   XmNborderColor, bg_color,
					   NULL);
    XtAddCallback(formant_button, XmNactivateCallback, goto_formant_target, 0);

    /*  Create Goto ratio target button */
    ratio_button = XtVaCreateManagedWidget("Go to ratio target",
					   xmPushButtonWidgetClass,
					   button_panel,
					   XmNleftAttachment, XmATTACH_WIDGET,
					   XmNleftWidget, drawing_area,
					   XmNtopAttachment, XmATTACH_WIDGET,
					   XmNtopWidget, formant_button,
					   XmNbackground, bg_color,
					   XmNborderColor, bg_color,
					   NULL);
    XtAddCallback(ratio_button, XmNactivateCallback, goto_ratio_target, 0);

    /*  Create babble_button */
    babble_button = XtVaCreateManagedWidget("Babble",
					   xmPushButtonWidgetClass,
					   button_panel,
					   XmNleftAttachment, XmATTACH_WIDGET,
					   XmNleftWidget, drawing_area,
					   XmNtopAttachment, XmATTACH_WIDGET,
					   XmNtopWidget, ratio_button,
					   XmNbackground, bg_color,
					   XmNborderColor, bg_color,
					   NULL);
    XtAddCallback(babble_button, XmNactivateCallback, babble, 0);

    /*  Create break button */
    break_button = XtVaCreateManagedWidget("Break",
					   xmPushButtonWidgetClass,
					   button_panel,
					   XmNleftAttachment, XmATTACH_WIDGET,
					   XmNleftWidget, drawing_area,
					   XmNtopAttachment, XmATTACH_WIDGET,
					   XmNtopWidget, babble_button,
					   XmNbackground, bg_color,
					   XmNborderColor, bg_color,
					   NULL);
    XtAddCallback(break_button, XmNactivateCallback, setbreak, 0);

#ifdef COMMENT
    /*  Create reset config button */
    reset_config_button = XtVaCreateManagedWidget("Reset Config",
					   xmPushButtonWidgetClass,
					   button_panel,
					   XmNleftAttachment, XmATTACH_WIDGET,
					   XmNleftWidget, drawing_area,
					   XmNtopAttachment, XmATTACH_WIDGET,
					   XmNtopWidget, break_button,
					   XmNbackground, bg_color,
					   XmNborderColor, bg_color,
					   NULL);
    XtAddCallback(reset_config_button, XmNactivateCallback, resetconfig, 0);
#endif COMMENT

    /* Create print config button */
    print_config_button = XtVaCreateManagedWidget("Print Config",
					   xmPushButtonWidgetClass,
					   button_panel,
					   XmNleftAttachment, XmATTACH_WIDGET,
					   XmNleftWidget, drawing_area,
					   XmNtopAttachment, XmATTACH_WIDGET,
					   XmNtopWidget, break_button,
					   XmNbackground, bg_color,
					   XmNborderColor, bg_color,
					   NULL);
    XtAddCallback(print_config_button, XmNactivateCallback, printconfig, 0);

    /*  Create Synthesize button */
    synthesize_button = XtVaCreateManagedWidget("Synthesize",
					   xmPushButtonWidgetClass,
					   button_panel,
					   XmNleftAttachment, XmATTACH_WIDGET,
					   XmNleftWidget, drawing_area,
					   XmNtopAttachment, XmATTACH_WIDGET,
					   XmNtopWidget, break_button,
					   XmNbackground, bg_color,
					   XmNborderColor, bg_color,
					   NULL);
    XtAddCallback(synthesize_button, XmNactivateCallback, synthbutton, 0);

    /*  Create Pause button */
    pause_button = XtVaCreateManagedWidget("Pause",
					   xmPushButtonWidgetClass,
					   button_panel,
					   XmNleftAttachment, XmATTACH_WIDGET,
					   XmNleftWidget, drawing_area,
					   XmNtopAttachment, XmATTACH_WIDGET,
					   XmNtopWidget, reset_config_button,
					   XmNbackground, bg_color,
					   XmNborderColor, bg_color,
					   NULL);
    XtAddCallback(pause_button, XmNactivateCallback, setpause, 0);

    /*  Create Pause After Phoneme button */
    cap_button = XtVaCreateManagedWidget("Cont after phoneme",
					   xmPushButtonWidgetClass,
					   button_panel,
					   XmNleftAttachment, XmATTACH_WIDGET,
					   XmNleftWidget, drawing_area,
					   XmNtopAttachment, XmATTACH_WIDGET,
					   XmNtopWidget, pause_button,
					   XmNbackground, bg_color,
					   XmNborderColor, bg_color,
					   NULL);
    XtAddCallback(cap_button, XmNactivateCallback, setcontinue, 0);

    /*  Create Fix F0 button */
#ifdef COMMENT
    fix_f0_button = XtVaCreateManagedWidget("Fix F0",
					   xmPushButtonWidgetClass,
					   button_panel,
					   XmNleftAttachment, XmATTACH_WIDGET,
					   XmNleftWidget, drawing_area,
					   XmNtopAttachment, XmATTACH_WIDGET,
					   XmNtopWidget, pause_button,
					   XmNbackground, bg_color,
					   XmNborderColor, bg_color,
					   NULL);
    XtAddCallback(fix_f0_button, XmNactivateCallback, setfixedf0, 0);
#endif COMMENT

    coord_frame_button = XtVaCreateManagedWidget("Using ratio coords",
					   xmPushButtonWidgetClass,
					   button_panel,
					   XmNleftAttachment, XmATTACH_WIDGET,
					   XmNleftWidget, drawing_area,
					   XmNtopAttachment, XmATTACH_WIDGET,
					   XmNtopWidget, pause_button,
					   XmNbackground, bg_color,
					   XmNborderColor, bg_color,
					   NULL);
    XtAddCallback(coord_frame_button, XmNactivateCallback, setcoordframe, 0);

    /*  Create Fix Jaw button */
    fix_jaw_button = XtVaCreateManagedWidget("Add lip tube",
					   xmPushButtonWidgetClass,
					   button_panel,
					   XmNleftAttachment, XmATTACH_WIDGET,
					   XmNleftWidget, drawing_area,
					   XmNtopAttachment, XmATTACH_WIDGET,
					   XmNtopWidget, coord_frame_button,
					   XmNbackground, bg_color,
					   XmNborderColor, bg_color,
					   NULL);
    XtAddCallback(fix_jaw_button, XmNactivateCallback, setfixedjaw, 0);

    /*  Create Load Weights button */
    load_weights_button = XtVaCreateManagedWidget("Load Weights",
					   xmPushButtonWidgetClass,
					   button_panel,
					   XmNleftAttachment, XmATTACH_WIDGET,
					   XmNleftWidget, drawing_area,
					   XmNtopAttachment, XmATTACH_WIDGET,
					   XmNtopWidget, fix_jaw_button,
					   XmNbackground, bg_color,
					   XmNborderColor, bg_color,
					   NULL);
    XtAddCallback(load_weights_button, XmNactivateCallback, 
		  load_weight_file_popup, 0);

    /*  Create save weights button */
    save_weights_button = XtVaCreateManagedWidget("Save Weights",
					   xmPushButtonWidgetClass,
					   button_panel,
					   XmNleftAttachment, XmATTACH_WIDGET,
					   XmNleftWidget, drawing_area,
					   XmNtopAttachment, XmATTACH_WIDGET,
					   XmNtopWidget, load_weights_button,
					   XmNbackground, bg_color,
					   XmNborderColor, bg_color,
					   NULL);
    XtAddCallback(save_weights_button, XmNactivateCallback, 
		  save_weight_file_popup, 0);

    /*  Create Load Parameters button */
    load_parameters_button = XtVaCreateManagedWidget("Load Parameters",
					   xmPushButtonWidgetClass,
					   button_panel,
					   XmNleftAttachment, XmATTACH_WIDGET,
					   XmNleftWidget, drawing_area,
					   XmNtopAttachment, XmATTACH_WIDGET,
					   XmNtopWidget, save_weights_button,
					   XmNbackground, bg_color,
					   XmNborderColor, bg_color,
					   NULL);
    XtAddCallback(load_parameters_button, XmNactivateCallback, 
		  load_parameter_file_popup, 0);

    /*  Create save parameters button */
    save_parameters_button = XtVaCreateManagedWidget("Save Parameters",
					   xmPushButtonWidgetClass,
					   button_panel,
					   XmNleftAttachment, XmATTACH_WIDGET,
					   XmNleftWidget, drawing_area,
					   XmNtopAttachment, XmATTACH_WIDGET,
					   XmNtopWidget, load_parameters_button,
					   XmNbackground, bg_color,
					   XmNborderColor, bg_color,
					   NULL);
    XtAddCallback(save_parameters_button, XmNactivateCallback, 
		  save_parameter_file_popup, 0);

    /*  Create plot config button */
    plot_conf_button = XtVaCreateManagedWidget("Plot Config",
					   xmPushButtonWidgetClass,
					   button_panel,
					   XmNleftAttachment, XmATTACH_WIDGET,
					   XmNleftWidget, drawing_area,
					   XmNtopAttachment, XmATTACH_WIDGET,
					   XmNtopWidget, save_parameters_button,
					   XmNbackground, bg_color,
					   XmNborderColor, bg_color,
					   NULL);
    XtAddCallback(plot_conf_button, XmNactivateCallback, 
		  plot_config_file_popup, 0);

    /*  Create make demo button */
    make_demo_button = XtVaCreateManagedWidget("Make Demo",
					   xmPushButtonWidgetClass,
					   button_panel,
					   XmNleftAttachment, XmATTACH_WIDGET,
					   XmNleftWidget, drawing_area,
					   XmNtopAttachment, XmATTACH_WIDGET,
					   XmNtopWidget, plot_conf_button,
					   XmNbackground, bg_color,
					   XmNborderColor, bg_color,
					   NULL);
    XtAddCallback(make_demo_button, XmNactivateCallback, 
		  make_demo_popup, 0);

    /*  Create play demo button */
    play_demo_button = XtVaCreateManagedWidget("Play Demo",
					   xmPushButtonWidgetClass,
					   button_panel,
					   XmNleftAttachment, XmATTACH_WIDGET,
					   XmNleftWidget, drawing_area,
					   XmNtopAttachment, XmATTACH_WIDGET,
					   XmNtopWidget, make_demo_button,
					   XmNbackground, bg_color,
					   XmNborderColor, bg_color,
					   NULL);
    XtAddCallback(play_demo_button, XmNactivateCallback, 
		  play_demo_popup, 0);


    /*  Create quit button */
    quit_button = XtVaCreateManagedWidget("Exit DIVA",
					   xmPushButtonWidgetClass,
					   button_panel,
					   XmNleftAttachment, XmATTACH_WIDGET,
					   XmNleftWidget, drawing_area,
					   XmNtopAttachment, XmATTACH_WIDGET,
					   XmNtopWidget,
						play_demo_button,
					   XmNbackground, bg_color,
					   XmNborderColor, bg_color,
					   NULL);
    XtAddCallback(quit_button, XmNactivateCallback, quit, 0);
}


/*******************************************************************/
/************************ Callback Routines ************************/
/*******************************************************************/


void setbreak(Widget w, caddr_t data, XEvent *p_event)
{
  BREAK = 1;
}


void resetconfig(Widget w, caddr_t data, XEvent *p_event)
{
  rest_config();
}

void printconfig(Widget w, caddr_t data, XEvent *p_event)
{
  static FILE *outfile;
  double eta,alpha;
  char filename[100];
  extern double get_etaB(),get_alpha();
  int i;

  eta = get_etaB();
  alpha = get_alpha();
  
  if(outfile==NULL){
     sprintf(filename, "E%.4lf_a%.3lf.config",eta,alpha);
     outfile = fopen(filename,"w");
     fprintf(outfile,"%%%%MaedaFile\n");
  }
  for(i=0;i<NUM_ARTICULATORS;i++)
     fprintf(outfile, "%lf ",AMpar[i]);
  fprintf(outfile,"\n");
  fflush(outfile);

} 




void setfixedf0(Widget w, caddr_t data, XEvent *p_event)
{
	if (FIX_F0 == 0) {
		FIX_F0 = 1;
		XtVaSetValues(fix_f0_button, XtVaTypedArg, XmNlabelString,
				XmRString, "Release F0", 7, NULL);
	}
	else {
		FIX_F0 = 0;
		XtVaSetValues(fix_f0_button, XtVaTypedArg, XmNlabelString,
				XmRString, "Fix F0", 17, NULL);
	}
}


void setcoordframe(Widget w, caddr_t data, XEvent *p_event)
{
  char filename[100],instring[30]; 
  FILE *infile;
  extern void load_weights();
  extern void load_rbf_weights();


	if (USE_RATIO_COORDS == 0) {
                printf("switching to ratio coords\n");
		USE_RATIO_COORDS = 1;

                strcpy(filename,DEFAULT_RATIO_ZPX);
                if ((infile = fopen(filename,"r")) != NULL)
                    fscanf(infile,"%s",instring);
                else
                {
                printf("File %s does not exist --\n",filename);
                }
               if (strcmp(instring,"%%WeightFile") == 0)
                   load_weights(infile);
               else
               {
                  printf("File %s is not a weight file --\n",filename);
                }
                fclose(infile);

                strcpy(filename,DEFAULT_RATIO_RBF);

                if ((infile = fopen(filename,"r")) != NULL)
		  {
                    fscanf(infile,"%s",instring);
                    if (strncmp(instring,"%%RbfWeightFile",15) == 0)
                       load_rbf_weights(infile);
                    else
                    {
                       printf("File %s isn't an rbf weight file --\n",filename);
                     }
		 }
                else
                {
                printf("File %s does not exist --\n",filename);
                }
                fclose(infile);

		XtVaSetValues(coord_frame_button, XtVaTypedArg, XmNlabelString,
				XmRString, "Using ratio coords", 19, NULL);
	}
	else {
                printf("switching to formant coords\n");
                strcpy(filename,DEFAULT_FRMT_ZPX);
                if ((infile = fopen(filename,"r")) != NULL)
                    fscanf(infile,"%s",instring);
                else
                {
                printf("File %s does not exist --\n",filename);
                }
               if (strcmp(instring,"%%WeightFile") == 0)
                   load_weights(infile);
               else
               {
                  printf("File %s is not a weight file --\n",filename);
                }
 
               fclose(infile);

                strcpy(filename,DEFAULT_FRMT_RBF);

                if ((infile = fopen(filename,"r")) != NULL)
		  {
                    fscanf(infile,"%s",instring);
                    if (strncmp(instring,"%%RbfWeightFile",15) == 0)
                       load_rbf_weights(infile);
                    else
                    {
                       printf("File %s is not an rbf weight file --\n",filename);
                     }
		 }
                else
                {
                printf("File %s does not exist --\n",filename);
                }
                fclose(infile);


		USE_RATIO_COORDS = 0;
		XtVaSetValues(coord_frame_button, XtVaTypedArg, XmNlabelString,
				XmRString, "Using formant coords", 20, NULL);
	}

}


void setfixedjaw(Widget w, caddr_t data, XEvent *p_event)
{
	if (FIX_JAW == 0) {
		FIX_JAW = 1;
		XtVaSetValues(fix_jaw_button, XtVaTypedArg, XmNlabelString,
				XmRString, "Remove lip tube", 12, NULL);
		XtSetSensitive(babble_button, FALSE);

		/*
		syn_targets[0] = syn_targets[0] + 0;
		syn_targets[1] = syn_targets[1] + 0; 450
		if (NUM_TARGETS > 2)
		  syn_targets[2] = syn_targets[2] + 0; 200
                */
                get_formants();
		display_formants();
		BLOCKED[0] = 1;
		BLOCKED[4] = 1;
		BLOCKED[5] = 1;
	     }
	else {
		FIX_JAW = 0;
		XtVaSetValues(fix_jaw_button, XtVaTypedArg, XmNlabelString,
				XmRString, "Add lip tube", 8, NULL);
		XtSetSensitive(babble_button, TRUE);
                /*
		syn_targets[0] = syn_targets[0] - 0;
		syn_targets[1] = syn_targets[1] - 0;
		if (NUM_TARGETS > 2)
		  syn_targets[2] = syn_targets[2] - 0;
		  */
		display_formants();
		BLOCKED[0] = 0;
		BLOCKED[4] = 0;
		BLOCKED[5] = 0;
	}
}


void setpause(Widget w, caddr_t data, XEvent *p_event)
{
	if (PAUSE == 0) {
		PAUSE = 1;
		XtVaSetValues(pause_button, XtVaTypedArg, XmNlabelString,
				XmRString, "Continue", 9, NULL);
	}
	else {
		PAUSE = 0;
		XtVaSetValues(pause_button, XtVaTypedArg, XmNlabelString,
				XmRString, "Pause", 6, NULL);
	}
}


void synthbutton(Widget w, caddr_t data, XEvent *p_event)
{
	int i;
	double min_area, temp;
	extern int synthesizing;
	extern void flush_sound();
	
	synthesizing = 1;
	temp = sound_on;
	sound_on = 1.0;

	shift_eye();
	flap_arms();

	/* Sustain sound for sufficient length of time. */
	for (i=0; i < 200; i++) {
		process_sound_frame();
/*
		frm_plot(syn_targets);
*/
	}

	/* flush the sound buffer (if necessary) */
	flush_sound();

        /* return to normal */
	synthesizing = 0;
	sound_on = temp;
	shift_eye();
	flap_arms();
}


void setcontinue(Widget w, caddr_t data, XEvent *p_event)
{
   CONTINUE_AFTER_PHONEME = 1;
}


void load_weight_file_popup(Widget w, char *text, 
		       XmPushButtonCallbackStruct *cbs)
{
  Arg args[1];
  Widget dialog;
  extern void cancel();
  extern void load_weight_file();
  
  XtSetArg(args[0], XmNbackground, bg_color); 
  dialog = XmCreateFileSelectionDialog(w, "Load weight file", args, 1);
  XtAddCallback(dialog, XmNokCallback, load_weight_file, NULL);
  XtAddCallback(dialog, XmNcancelCallback, cancel, NULL);

  XtManageChild(dialog);
  XtPopup(XtParent(dialog), XtGrabNone);
}


void plot_config_file_popup(Widget w, char *text, 
		       XmPushButtonCallbackStruct *cbs)
{
  Arg args[1];
  Widget dialog;
  extern void cancel();
  extern void plot_config_file();
  
  XtSetArg(args[0], XmNbackground, bg_color); 
  dialog = XmCreateFileSelectionDialog(w, "plot configuration file", args, 1);
  XtAddCallback(dialog, XmNokCallback, plot_config_file, NULL);
  XtAddCallback(dialog, XmNcancelCallback, cancel, NULL);

  XtManageChild(dialog);
  XtPopup(XtParent(dialog), XtGrabNone);
}


void make_demo_popup(Widget w, char *text, 
		       XmPushButtonCallbackStruct *cbs)
{
  Arg args[1];
  Widget dialog;
  extern void cancel();
  extern void make_demo_file();
  
  XtSetArg(args[0], XmNbackground, bg_color); 
  dialog = XmCreateFileSelectionDialog(w, "make demo", args, 1);
  XtAddCallback(dialog, XmNokCallback, make_demo_file, NULL);
  XtAddCallback(dialog, XmNcancelCallback, cancel, NULL);

  XtManageChild(dialog);
  XtPopup(XtParent(dialog), XtGrabNone);
}


void play_demo_popup(Widget w, char *text, 
		       XmPushButtonCallbackStruct *cbs)
{
  Arg args[1];
  Widget dialog;
  extern void cancel();
  extern void play_demo_file();
  
  XtSetArg(args[0], XmNbackground, bg_color); 
  dialog = XmCreateFileSelectionDialog(w, "play demo", args, 1);
  XtAddCallback(dialog, XmNokCallback, play_demo_file, NULL);
  XtAddCallback(dialog, XmNcancelCallback, cancel, NULL);

  XtManageChild(dialog);
  XtPopup(XtParent(dialog), XtGrabNone);
}


void load_weight_file(Widget w, XtPointer client_data, 
	       XmFileSelectionBoxCallbackStruct *cbs)
{
  Widget dialog;
  XmString xm_string;
  Arg args[1];
  char *filename;
  char instring[100];
  FILE *infile;
  extern void cancel();
  extern void load_weights();
  extern void load_rbf_weights();

  if (!XmStringGetLtoR(cbs->value, XmSTRING_DEFAULT_CHARSET, &filename))
    return; /* must have been an internal error */

  if(!*filename)
    {
      puts("No file selected.");
      XtFree(filename);
      return;
    }

  if ((infile = fopen(filename,"r")) == NULL)
    {
      xm_string = XmStringCreateSimple("File does not exist;  try again.");
      XtSetArg(args[0], XmNmessageString, xm_string);
      dialog = XmCreateInformationDialog(w, "info", args, 1);
      XmStringFree(xm_string);
      XtManageChild(dialog);
      XtPopup(XtParent(dialog), XtGrabNone);
      return;
    }

  fscanf(infile,"%s",instring);
  if(strcmp(instring,"%%WeightFile")==0)
  {
    printf("File:  \"%s\" has been opened\n",filename);
    load_weights(infile);
    XtFree(filename);
    XtPopdown(XtParent(w));
  }
  else
  {
    rewind(infile);

    fscanf(infile,"%s",instring);
    if(strncmp(instring,"%%RbfWeightFile",15)==0)
    {
      printf("File:  \"%s\" has been opened, new rbfs loaded\n",filename);
      load_rbf_weights(infile);  /* this function accesses the RBF struct P */
      XtFree(filename);
      XtPopdown(XtParent(w));
      printf("i\n");
    }
    else
      {
      xm_string = XmStringCreateSimple("This is not a weight file.");
      XtSetArg(args[0], XmNmessageString, xm_string);
      dialog = XmCreateInformationDialog(w, "info", args, 1);
      XmStringFree(xm_string);
      XtManageChild(dialog);
      XtPopup(XtParent(dialog), XtGrabNone);
      return;
      }
 }
}


void load_parameter_file_popup(Widget w, char *text, 
		       XmPushButtonCallbackStruct *cbs)
{
  Arg args[1];
  Widget dialog;
  extern void cancel();
  extern void load_parameter_file();
  
  XtSetArg(args[0], XmNbackground, bg_color); 
  dialog = XmCreateFileSelectionDialog(w, "Load parameter file", args, 1);
  XtAddCallback(dialog, XmNokCallback, load_parameter_file, NULL);
  XtAddCallback(dialog, XmNcancelCallback, cancel, NULL);
  XtManageChild(dialog);
  XtPopup(XtParent(dialog), XtGrabNone);
}


void load_parameter_file(Widget w, XtPointer client_data, 
	       XmFileSelectionBoxCallbackStruct *cbs)
{
  Widget dialog;
  XmString xm_string;
  Arg args[1];
  char instring[100];
  char *filename;
  FILE *infile;
  extern void cancel();

  if (!XmStringGetLtoR(cbs->value, XmSTRING_DEFAULT_CHARSET, &filename))
    return; /* must have been an internal error */

  if(!*filename)
    {
      puts("No file selected.");
      XtFree(filename);
      return;
    }

  if ((infile = fopen(filename,"r")) == NULL)
    {
      xm_string = XmStringCreateSimple("File does not exist;  try again.");
      XtSetArg(args[0], XmNmessageString, xm_string);
      dialog = XmCreateInformationDialog(w, "info", args, 1);
      XmStringFree(xm_string);
      XtManageChild(dialog);
      XtPopup(XtParent(dialog), XtGrabNone);
      return;
    }

  fscanf(infile,"%s",instring);
  if (strcmp(instring,"%%ParameterFile") != 0)
    {
      xm_string = XmStringCreateSimple("This is not a parameter file.");
      XtSetArg(args[0], XmNmessageString, xm_string);
      dialog = XmCreateInformationDialog(w, "info", args, 1);
      XmStringFree(xm_string);
      XtManageChild(dialog);
      XtPopup(XtParent(dialog), XtGrabNone);
      return;
    }
  read_parameter_file(infile);
  XtFree(filename);
  XtPopdown(XtParent(w));
}


void plot_config_file(Widget w, XtPointer client_data, 
	       XmFileSelectionBoxCallbackStruct *cbs)
{
  Widget dialog;
  XmString xm_string;
  Arg args[1];
  char instring[100];
  char *filename;
  FILE *infile;
  extern void cancel();

  if (!XmStringGetLtoR(cbs->value, XmSTRING_DEFAULT_CHARSET, &filename))
    return; /* must have been an internal error */

  if(!*filename)
    {
      puts("No file selected.");
      XtFree(filename);
      return;
    }

  if ((infile = fopen(filename,"r")) == NULL)
    {
      xm_string = XmStringCreateSimple("File does not exist;  try again.");
      XtSetArg(args[0], XmNmessageString, xm_string);
      dialog = XmCreateInformationDialog(w, "info", args, 1);
      XmStringFree(xm_string);
      XtManageChild(dialog);
      XtPopup(XtParent(dialog), XtGrabNone);
      return;
    }

  fscanf(infile,"%s",instring);
  if (strcmp(instring,"%%MaedaFile") != 0)
    {
      xm_string = XmStringCreateSimple("This is not a Maeda parameter file.");
      XtSetArg(args[0], XmNmessageString, xm_string);
      dialog = XmCreateInformationDialog(w, "info", args, 1);
      XmStringFree(xm_string);
      XtManageChild(dialog);
      XtPopup(XtParent(dialog), XtGrabNone);
      return;
    }
  plot_config(infile);
  XtFree(filename);
  XtPopdown(XtParent(w));
}


void make_demo_file(Widget w, XtPointer client_data, 
	       XmFileSelectionBoxCallbackStruct *cbs)
{
  Widget dialog;
  XmString xm_string;
  Arg args[1];
  char instring[100];
  char *filename;
  double temp;
  extern FILE *sound_file_ptr;
  extern int record_demo;

  extern void cancel();
  extern void speak();
  extern void babble();

  if (!XmStringGetLtoR(cbs->value, XmSTRING_DEFAULT_CHARSET, &filename))
    return; /* must have been an internal error */

  if(!*filename)
    {
      puts("No file selected.");
      XtFree(filename);
      return;
    }

  if ((sound_file_ptr = fopen(filename,"w")) == NULL)
    {
      xm_string = XmStringCreateSimple("Can't create demo file.");
      XtSetArg(args[0], XmNmessageString, xm_string);
      dialog = XmCreateInformationDialog(w, "info", args, 1);
      XmStringFree(xm_string);
      XtManageChild(dialog);
      XtPopup(XtParent(dialog), XtGrabNone);
      return;
    }

  chmod(filename, S_IRUSR | S_IWUSR | S_IRGRP | S_IWGRP );

  temp = sound_on;
  sound_on = 1.0;
  record_demo = 1;
  speak();
#ifdef COMMENT
  /* in case you want to make a babbling demo instead of speak() above */
  babble();
#endif COMMENT
  record_demo = 0;
  sound_on = temp;

  XtFree(filename);
  
  fclose(sound_file_ptr);
  XtPopdown(XtParent(w));
}


void play_demo_file(Widget w, XtPointer client_data, 
	       XmFileSelectionBoxCallbackStruct *cbs)
{
  Widget dialog;
  XmString xm_string;
  Arg args[1];
  char instring[100];
  char *filename;
  FILE *infile;
  extern void cancel();
  extern void play_demo();

  if (!XmStringGetLtoR(cbs->value, XmSTRING_DEFAULT_CHARSET, &filename))
    return; /* must have been an internal error */

  if(!*filename)
    {
      puts("No file selected.");
      XtFree(filename);
      return;
    }

  if ((infile = fopen(filename,"r")) == NULL)
    {
      xm_string = XmStringCreateSimple("File does not exist;  try again.");
      XtSetArg(args[0], XmNmessageString, xm_string);
      dialog = XmCreateInformationDialog(w, "info", args, 1);
      XmStringFree(xm_string);
      XtManageChild(dialog);
      XtPopup(XtParent(dialog), XtGrabNone);
      return;
    }
  play_demo(infile);
  XtFree(filename);
  XtPopdown(XtParent(w));
}


void save_weight_file_popup(Widget w, char *text, 
		       XmPushButtonCallbackStruct *cbs)
{
  Arg args[1];
  Widget dialog;
  extern void cancel();
  extern void save_weights();
  
  XtSetArg(args[0], XmNbackground, bg_color); 
  dialog = XmCreateFileSelectionDialog(w, "Save weight file", args, 1);
  XtAddCallback(dialog, XmNokCallback, save_weights, NULL);
  XtAddCallback(dialog, XmNcancelCallback, cancel, NULL);
  XtManageChild(dialog);
  XtPopup(XtParent(dialog), XtGrabNone);
}


void save_weights(Widget w, XtPointer client_data, 
	       XmFileSelectionBoxCallbackStruct *cbs)
{
  Widget dialog;
  XmString xm_string;
  Cardinal argcount;
  Arg args[10];
  FILE *outfile;
  extern void cancel();
  extern void overwrite_weights();

  if (!XmStringGetLtoR(cbs->value, XmSTRING_DEFAULT_CHARSET, &savefilename))
    return; /* must have been an internal error */

  if(!*savefilename)
    {
      puts("No file selected.");
      return;
    }

  if ((outfile = fopen(savefilename,"r")) != NULL)
    {
	xm_string = XmStringCreateSimple("File exists;  OK to overwrite?");
	argcount = 0;
	XtSetArg(args[argcount], XmNmessageString, xm_string); argcount++;
	dialog = XmCreateWarningDialog(w, "info", args, argcount);
	XtAddCallback(dialog, XmNokCallback, overwrite_weights, NULL);
	XmStringFree(xm_string);
	XtManageChild(dialog);
	XtPopup(XtParent(dialog), XtGrabNone);
	fclose(outfile);
    }
  else
    {
	fclose(outfile);
	outfile = fopen(savefilename,"w");
	print_weights(outfile);
	printf("Weights stored in '%s'\n",savefilename);
    }
  XtPopdown(XtParent(w));
}


void overwrite_weights(Widget w)
{
    FILE *outfile;
    extern char *savefilename;

    outfile = fopen(savefilename,"w");
    print_weights(outfile);
    printf("Weights stored in '%s'\n",savefilename);
}


void save_parameter_file_popup(Widget w, char *text, 
		       XmPushButtonCallbackStruct *cbs)
{
  Arg args[1];
  Widget dialog;
  extern void cancel();
  extern void save_parameters();
  
  XtSetArg(args[0], XmNbackground, bg_color); 
  dialog = XmCreateFileSelectionDialog(w, "Save parameter file", args, 1);
  XtAddCallback(dialog, XmNokCallback, save_parameters, NULL);
  XtAddCallback(dialog, XmNcancelCallback, cancel, NULL);
  XtManageChild(dialog);
  XtPopup(XtParent(dialog), XtGrabNone);
}


void save_parameters(Widget w, XtPointer client_data, 
	       XmFileSelectionBoxCallbackStruct *cbs)
{
  Widget dialog;
  XmString xm_string;
  Cardinal argcount;
  Arg args[10];
  FILE *infile;
  extern char *savefilename;
  extern void cancel();
  extern void overwrite_params();

  if (!XmStringGetLtoR(cbs->value, XmSTRING_DEFAULT_CHARSET, &savefilename))
    return; /* must have been an internal error */

  if(!*savefilename)
    {
      puts("No file selected.");
      XtFree(savefilename);
      return;
    }

  if ((infile = fopen(savefilename,"r")) != NULL)
    {
      xm_string = XmStringCreateSimple("File exists;  OK to overwrite?");
      argcount = 0;
      XtSetArg(args[argcount], XmNmessageString, xm_string); argcount++;
      dialog = XmCreateWarningDialog(w, "info", args, argcount);
      XtAddCallback(dialog, XmNokCallback, overwrite_params, NULL);
      XmStringFree(xm_string);
      XtManageChild(dialog);
      XtPopup(XtParent(dialog), XtGrabNone);
      fclose(infile);
    }
  else
    {
	fclose(infile);
	infile = fopen(savefilename,"w");
	print_parameters(infile);
	printf("Parameters stored in '%s'\n",savefilename);
    }
  XtPopdown(XtParent(w));
}


void overwrite_params(Widget w)
{
    FILE *infile;
    extern char *savefilename;

    infile = fopen(savefilename,"w");
    print_parameters(infile);
    printf("Parameters stored in '%s'\n",savefilename);
}


void handle_expose(Widget w, caddr_t data, XEvent *p_event)
{
  draw_man();
  frm_replot();
}

void quit(Widget w, caddr_t data, XEvent *p_event)
{
  exit(0);
}

void change_jaw_height(Widget w, XtPointer client_data, 
		  XmScaleCallbackStruct *cbs)
{

  AMpar[0] = (double)cbs->value/(double)100;
  draw_maeda_articulators();
  frm_plot(syn_targets);
  get_tessellated_bin();

  display_formants();
}

void change_tongue_body_position(Widget w, XtPointer client_data, 
		  XmScaleCallbackStruct *cbs)
{
  AMpar[1] = (double)cbs->value/(double)100;
  draw_maeda_articulators();
  frm_plot(syn_targets);
  get_tessellated_bin();

  display_formants();
}

void change_tongue_body_shape(Widget w, XtPointer client_data, 
		  XmScaleCallbackStruct *cbs)
{
  AMpar[2] = (double)cbs->value/(double)100;
  draw_maeda_articulators();
  frm_plot(syn_targets);
  get_tessellated_bin();

  display_formants();
}

void change_tongue_tip_position(Widget w, XtPointer client_data, 
		  XmScaleCallbackStruct *cbs)
{
  AMpar[3] = (double)cbs->value/(double)100;
  draw_maeda_articulators();
  frm_plot(syn_targets);
  get_tessellated_bin();

  display_formants();
}

void change_lip_aperture(Widget w, XtPointer client_data, 
		  XmScaleCallbackStruct *cbs)
{
  AMpar[4] = (double)cbs->value/(double)100;
  draw_maeda_articulators();
  frm_plot(syn_targets);
  get_tessellated_bin();

  display_formants();
  /*
  which_fmap = 2;
  get_formants();
  printf("maeda: %lf %lf %lf\n",syn_targets[0],syn_targets[1],syn_targets[2]);

  which_fmap = 1;
  get_formants();
  printf("rbfs : %lf %lf %lf\n",syn_targets[0],syn_targets[1],syn_targets[2]);
  */
}

void change_lip_protrusion(Widget w, XtPointer client_data, 
		  XmScaleCallbackStruct *cbs)
{
  AMpar[5] = (double)cbs->value/(double)100;
  draw_maeda_articulators();
  frm_plot(syn_targets);
  get_tessellated_bin();
  display_formants();
}

void change_larynx_height(Widget w, XtPointer client_data, 
		  XmScaleCallbackStruct *cbs)
{
  AMpar[6] = (double)cbs->value/(double)100;
  draw_maeda_articulators();
  frm_plot(syn_targets);
  get_tessellated_bin();

  display_formants();
}

void change_speed(Widget w, XtPointer client_data, 
		  XmScaleCallbackStruct *cbs)
{
  ANIMATION_SPEED = cbs->value;
}

void change_speaking_rate(Widget w, XtPointer client_data, 
			  XmScaleCallbackStruct *cbs)
{
  SPEAKING_RATE = cbs->value;
}


#ifdef COMMENT
void fix_jaw(Widget w, XtPointer client_data, XmScaleCallbackStruct *cbs)
{
  FIX_JAW = 1;
  LIP_PERT = 0;
  JAW_PERT = 0;
  printf("Jaw fixed.\n");
}


void jaw_pert(Widget w, XtPointer client_data, XmScaleCallbackStruct *cbs)
{
  FIX_JAW = 0;
  LIP_PERT = 0;
  JAW_PERT = 1;
  printf("Jaw perturbation set.\n");
}


void lip_pert(Widget w, XtPointer client_data, XmScaleCallbackStruct *cbs)
{
  FIX_JAW = 0;
  LIP_PERT = 1;
  JAW_PERT = 0;
  printf("Jaw perturbation set.\n");
}


void no_pert(Widget w, XtPointer client_data, XmScaleCallbackStruct *cbs)
{
  FIX_JAW = 0;
  LIP_PERT = 0;
  JAW_PERT = 0;
  printf("All perturbations inactivated.\n");
}
#endif COMMENT


void set_random(Widget w, XtPointer client_data, XmScaleCallbackStruct *cbs)
{
  strcpy(BABBLE_TYPE, "random");
  if (cbs->value == 1)
    printf("Babble type set to %s\n", BABBLE_TYPE);
}


void set_variegated(Widget w, XtPointer client_data, 
			  XmScaleCallbackStruct *cbs)
{
  strcpy(BABBLE_TYPE, "variegated");
  if (cbs->value == 1)
    printf("Babble type set to %s\n", BABBLE_TYPE);
}




void get_phoneme_string(Widget w, XtPointer client_data,
			XmFileSelectionBoxCallbackStruct *cbs)
{
  char *text=XmTextFieldGetString(w);
  strcpy(PHONEME_STRING, text);
  XtFree(text);
}

void mouse_button_press(Widget w, XtPointer client_data, XButtonEvent *event)
{
    int i, j, remove_marker = 0, closest = 1;
    double distance = 5000.0;

    if (event->button == Button1)
      {
	  rest_config();
      }

    if (event->button == Button2)
      {
	  for (i = 1; i <= MARKER_COUNT; i++)
	    {
		if ((abs(event->x - MARKER[i][0]) <= 5) &&
		    (abs(event->y - MARKER[i][1]) <= 5) && 
		    (remove_marker == 0))
		  {
		      remove_marker = 1;
		      MARKER_COUNT = MARKER_COUNT - 1;
		      for (j = i; j <= MARKER_COUNT; j++)
			{
			    MARKER[j][0] = MARKER[j + 1][0];
			    MARKER[j][1] = MARKER[j + 1][1];
			}
		  }
	    }
	  if (remove_marker == 0)
	    {
		MARKER_COUNT = MARKER_COUNT + 1;
		MARKER[MARKER_COUNT][0] = event->x;
		MARKER[MARKER_COUNT][1] = event->y;
	    }
	  XClearWindow(theDisplay,theWindow);
	  draw_man();
	  frm_replot();
      }

#ifdef COMMENT
    if (event->button == Button3)
      {
	  for (i = 1; i <= TRACER_COUNT; i++)
	    {
		if ((abs(event->x - 
			 (ARTIC_POS[TRACER_ARTIC[i]][0] +
			  TRACER_OFFSET[i][0])) <= 5) &&
		    (abs(event->y - 
			 (ARTIC_POS[TRACER_ARTIC[i]][1] +
			  TRACER_OFFSET[i][1])) <= 5) && 
		    (remove_marker == 0))
		  {
		      remove_marker = 1;
		      TRACER_COUNT = TRACER_COUNT - 1;
		      for (j = i; j <= TRACER_COUNT; j++)
			{
			    TRACER_ARTIC[j] = TRACER_ARTIC[j + 1];
			    TRACER_OFFSET[j][0] = TRACER_OFFSET[j + 1][0];
			    TRACER_OFFSET[j][1] = TRACER_OFFSET[j + 1][1];
			}
		  }
	    }
	  if (remove_marker == 0)
	    {
		for (i = 1; i <= NUM_ARTICULATORS; i++)
		  {
		      if (sqrt(((event->x - ARTIC_POS[i][0]) *
				(event->x - ARTIC_POS[i][0])) +
			       ((event->y - ARTIC_POS[i][1]) *
				(event->y - ARTIC_POS[i][1]))) < distance)
			{
			    distance = sqrt(((event->x - ARTIC_POS[i][0]) *
					     (event->x - ARTIC_POS[i][0])) +
					    ((event->y - ARTIC_POS[i][1]) *
					     (event->y - ARTIC_POS[i][1])));
			    closest = i;
			}
		  }
		TRACER_COUNT = TRACER_COUNT + 1;
		TRACER_ARTIC[TRACER_COUNT] = closest;
		TRACER_OFFSET[TRACER_COUNT][0] = event->x - 
		  (int)ARTIC_POS[closest][0];
		TRACER_OFFSET[TRACER_COUNT][1] = event->y -
		  (int)ARTIC_POS[closest][1];
	    }
	  XClearWindow(theDisplay,theWindow);
	  draw_man();
	  frm_replot();
      }
#endif COMMENT
}


void get_param_name(Widget w, char *text, 
		    XmPushButtonCallbackStruct *cbs)
{
  Arg args[20];
  Cardinal argcount;
  Widget dialog;
  extern XmString param_list[];
  extern void cancel();
  extern void get_param_value();
  int i;


  argcount = 0;
  XtSetArg(args[argcount], XmNlistVisibleItemCount, 
	   (param_count+1)); argcount++;
  XtSetArg(args[argcount], XmNlistItems, param_list); argcount++;
  XtSetArg(args[argcount], XmNlistItemCount, (param_count + 1)); argcount++;
  XtSetArg(args[argcount], XmNbackground, bg_color); argcount++;
  XtSetArg(args[argcount], XmNmustMatch, True); argcount++;
  dialog = XmCreateSelectionDialog(w, "Get parameter name", args, argcount);
  XtAddCallback(dialog, XmNokCallback, get_param_value, NULL);
  XtAddCallback(dialog, XmNcancelCallback, cancel, NULL);
  XtManageChild(dialog);
  XtPopup(XtParent(dialog), XtGrabNone);
}

void cancel(Widget w)
{
  XtPopdown(XtParent(w));
}

void get_param_value(Widget w, char *text, 
		    XmSelectionBoxCallbackStruct *cbs)
{
    extern double get_parameter();
    char val[20] = "";

    XtVaSetValues(param_button, XmNlabelString, cbs->value, NULL);
    XmStringGetLtoR(cbs->value,XmSTRING_DEFAULT_CHARSET,&CURRENT_PARAMETER);
    printf("%s = %lf\n",CURRENT_PARAMETER,get_parameter(CURRENT_PARAMETER));
    sprintf(val,"%0.3lf",get_parameter(CURRENT_PARAMETER));
    XmTextSetString(param_value_string, val);
    XtPopdown(XtParent(w));
}


void param_value_activate(Widget w, char *text, 
		    XmAnyCallbackStruct *cbs)
{
	char str_val[20] = "";
	double val=0.0;
	char *ptext=XmTextFieldGetString(w);

	sscanf(ptext,"%lf",&val);
	set_parameter(CURRENT_PARAMETER,val);
	XtFree(ptext);
	printf("%s: new value = %f\n", CURRENT_PARAMETER,val);
}


void update_maeda_sliders( void )
{
	int i;

	for (i=0; i<7; i++)
		AMpar_int[i] = (int)(100*AMpar[i]);

	XmScaleSetValue(jaw_height_scale, AMpar_int[0]);
	XmScaleSetValue(tongue_body_position_scale, AMpar_int[1]);
	XmScaleSetValue(tongue_body_shape_scale, AMpar_int[2]);
	XmScaleSetValue(tongue_tip_position_scale, AMpar_int[3]);
	XmScaleSetValue(lip_aperture_scale, AMpar_int[4]);
	XmScaleSetValue(lip_protrusion_scale, AMpar_int[5]);
	XmScaleSetValue(larynx_height_scale, AMpar_int[6]);
	XFlush(theDisplay);
}


void display_formants( void )
{
        double SF0;
	char val[20] = "";
	extern int babbling_flag;

	SF0 = get_SF0(F0);
	sprintf(val,"%.2lf",F0);
	XmTextSetString(F0_string, val);
	sprintf(val,"%.2lf",SF0);
	XmTextSetString(SF0_string, val);
	sprintf(val,"%.0lf",syn_targets[0]);
	XmTextSetString(F1_value_string, val);
	sprintf(val,"%.0lf",syn_targets[1]);
	XmTextSetString(F2_value_string, val);
	sprintf(val,"%.0lf",syn_targets[2]);
	XmTextSetString(F3_value_string, val);
	sprintf(val,"%.2lf",get_min_area());
	XmTextSetString(min_area_string, val);

	sprintf(val,"%.3lf",log10(syn_targets[0]/SF0));
	XmTextSetString(ratio1_value_string, val);
	sprintf(val,"%.3lf",log10(syn_targets[1]/syn_targets[0]));
	XmTextSetString(ratio2_value_string, val);
	sprintf(val,"%.3lf",log10(syn_targets[2]/syn_targets[1]));
	XmTextSetString(ratio3_value_string, val);
	XFlush(theDisplay);
}


void goto_formant_target(Widget w, char *text, XmPushButtonCallbackStruct *cbs)
{
   extern void speak();

   FORMANT_TARGET_FLAG = 1;
   if(NUM_TARGETS >3) FORMANT_TARGET[3] = 600.0;
   speak();
   FORMANT_TARGET_FLAG = 0;
}

void goto_ratio_target(Widget w, char *text, XmPushButtonCallbackStruct *cbs)
{
   extern void speak();

   RATIO_TARGET_FLAG = 1;
   if(NUM_TARGETS>3){
      FORMANT_TARGET[3] = 600.0;
      RATIO_TARGET[3] = FORMANT_TARGET[3]/600.0;
   }
   speak();
   RATIO_TARGET_FLAG = 0;
}


void get_f1_target(Widget w, XtPointer client_data,
			XmFileSelectionBoxCallbackStruct *cbs)
{
  char *text=XmTextFieldGetString(w);
  
  if (NUM_TARGETS > 0)
    {
       sscanf(text,"%lf",&FORMANT_TARGET[0]);
       XtFree(text);
    }
  else
    printf("WARNING -- F1 not currently used -- target ignored.\n");
}


void get_f2_target(Widget w, XtPointer client_data,
			XmFileSelectionBoxCallbackStruct *cbs)
{
  char *text=XmTextFieldGetString(w);
  
  if (NUM_TARGETS > 1)
    {
       sscanf(text,"%lf",&FORMANT_TARGET[1]);
       XtFree(text);
    }
  else
    printf("WARNING -- F2 not currently used -- target ignored.\n");
}


void get_f3_target(Widget w, XtPointer client_data,
			XmFileSelectionBoxCallbackStruct *cbs)
{
  char *text=XmTextFieldGetString(w);
  
  if (NUM_TARGETS > 2)
    {
       sscanf(text,"%lf",&FORMANT_TARGET[2]);
       XtFree(text);
    }
  else
    printf("WARNING -- F3 not currently used -- target ignored.\n");
}


void get_ratio1_target(Widget w, XtPointer client_data,
			XmFileSelectionBoxCallbackStruct *cbs)
{
  char *text=XmTextFieldGetString(w);
  
  sscanf(text,"%lf",&RATIO_TARGET[0]);
  XtFree(text);
}


void get_ratio2_target(Widget w, XtPointer client_data,
			XmFileSelectionBoxCallbackStruct *cbs)
{
  char *text=XmTextFieldGetString(w);
  
  sscanf(text,"%lf",&RATIO_TARGET[1]);
  XtFree(text);
}


void get_ratio3_target(Widget w, XtPointer client_data,
			XmFileSelectionBoxCallbackStruct *cbs)
{
  char *text=XmTextFieldGetString(w);
  
  sscanf(text,"%lf",&RATIO_TARGET[2]);
  XtFree(text);
}


void get_f0(Widget w, XtPointer client_data,
			XmFileSelectionBoxCallbackStruct *cbs)
{
   char *text=XmTextFieldGetString(w);
   char val[20] = "";
   double SF0;

   sscanf(text,"%lf",&F0);
   XtFree(text);
   SF0 = get_SF0(F0);
   sprintf(val,"%.3lf",log10(syn_targets[0]/SF0));
   XmTextSetString(ratio1_value_string, val);
   sprintf(val,"%.2lf",SF0);
   XmTextSetString(SF0_string, val);
}


void get_list_selection(Widget w, XtPointer client_data,
			XmListCallbackStruct *cbs)
{
   char val[20];
   int i;

   for (i = 0; i < 3; i ++)
     {
	FORMANT_TARGET[i] = IDEAL_FORMANTS[cbs->item_position-1][i];
	RATIO_TARGET[i] = IDEAL_RATIOS[cbs->item_position-1][i];
     }
   
   sprintf(val,"%.3lf",RATIO_TARGET[0]);
   XmTextSetString(ratio1_target_string, val);
   sprintf(val,"%.3lf",RATIO_TARGET[1]);
   XmTextSetString(ratio2_target_string, val);
   sprintf(val,"%.3lf",RATIO_TARGET[2]);
   XmTextSetString(ratio3_target_string, val);

   sprintf(val,"%.0lf",FORMANT_TARGET[0]);
   XmTextSetString(F1_target_string, val);
   sprintf(val,"%.0lf",FORMANT_TARGET[1]);
   XmTextSetString(F2_target_string, val);
   sprintf(val,"%.0lf",FORMANT_TARGET[2]);
   XmTextSetString(F3_target_string, val);

   if (cbs->item_position == 2)  /* E */
     sprintf(val,"%c",'E');
   if (cbs->item_position == 3)  /* i */
     sprintf(val,"%c",'i');
   if (cbs->item_position == 4)  /* e */
     sprintf(val,"%c",'e');
   if (cbs->item_position == 5)  /* a */
     sprintf(val,"%c",'a');
   if (cbs->item_position == 6)  /* C */
     sprintf(val,"%c",'C');
   if (cbs->item_position == 7)  /* c */
     sprintf(val,"%c",'c');
   if (cbs->item_position == 8)  /* o */
     sprintf(val,"%c",'o');
   if (cbs->item_position == 9)  /* U */
     sprintf(val,"%c",'U');
   if (cbs->item_position == 10)  /* u */
     sprintf(val,"%c",'u');
   if (cbs->item_position == 11)  /* I */
     sprintf(val,"%c",'I');
   if (cbs->item_position == 12)  /* F */
     sprintf(val,"%c",'F');

   XmTextSetString(speak_string, val);
   strcpy(PHONEME_STRING, val);
}

void fix_artic_0(Widget w, XtPointer client_data, 
		 XmToggleButtonCallbackStruct *cbs)
{
   BLOCKED[0] = cbs->set;
}

void fix_artic_1(Widget w, XtPointer client_data, 
		 XmToggleButtonCallbackStruct *cbs)
{
   BLOCKED[1] = cbs->set;
}

void fix_artic_2(Widget w, XtPointer client_data, 
		 XmToggleButtonCallbackStruct *cbs)
{
   BLOCKED[2] = cbs->set;
}

void fix_artic_3(Widget w, XtPointer client_data, 
		 XmToggleButtonCallbackStruct *cbs)
{
   BLOCKED[3] = cbs->set;
}

void fix_artic_4(Widget w, XtPointer client_data, 
		 XmToggleButtonCallbackStruct *cbs)
{
   BLOCKED[4] = cbs->set;
}

void fix_artic_5(Widget w, XtPointer client_data, 
		 XmToggleButtonCallbackStruct *cbs)
{
   BLOCKED[5] = cbs->set;
}

void fix_artic_6(Widget w, XtPointer client_data, 
		 XmToggleButtonCallbackStruct *cbs)
{
   BLOCKED[6] = cbs->set;
}

