/** to add a parameter, edit set_parameter, get_parameter, and **/
/** the file parameter.dat, as well as adding the parameter to **/
/** the declaration lists here and in diva.h.		       **/

#include "diva.h"

double get_parameter(char name[]);
void set_parameter(char name[], double value);

/******* Parameters (see also parameters.dat) ***********/
/*** MUST BE TYPE double !!! *********/
double which_fmap;  
double phoneme_learning_rate = 0.1;  /*** learning rate parameter for zxm ***/
                                     /*** 2.0 for separately learned zxm ****/
double phoneme_decay_rate = 0.01;    /*** decay rate for zxm ***/
                                     /*** 0.0 for separately learned zxm ****/
double velocity_learning_rate = 0.2; /*** learning rate parameter for zpx***/
double velocity_decay_rate = 0.0;    /*** decay rate for zpx ***/
double trial_length = 0.11;          /*** Amount of learning per trial ***/
double time_step = 0.1;              /*** Integrator time increment    ***/
double lip_perturb_height = 380;
double jaw_perturb_height = 45;
double jaw_fixed_height = 45;
double num_velocity_trials = 500;
double num_phoneme_trials = 5000;
double min_cube_factor = 0.2;  /** between zero and 1;  determines how big
				   (percentage-wise) minimum cube size 
				   (slowest speed) is compared to maximum
				   cube size **/
double coartic_distance = 0;   /*** number of phonemes to look ahead ***/
double scale = 1.0;
double stop_after_phoneme = 0.0;
double babbling_graphics_on = 1.0;
double sound_on = 1.0;			/* sound written to /dev/audio */
/********** End parameters ***********************/

double get_parameter(char name[])
{
 
    if (strcmp(name, "which_fmap") == 0)
      {
	  return(which_fmap);
      }
    if (strcmp(name, "phoneme_learning_rate") == 0)
      {
	  return(phoneme_learning_rate);
      }
    if (strcmp(name, "phoneme_decay_rate") == 0)
      {
	  return(phoneme_decay_rate);
      }
    if (strcmp(name, "velocity_learning_rate") == 0)
      {
	  return(velocity_learning_rate);
      }
    if (strcmp(name, "velocity_decay_rate") == 0)
      {
	  return(velocity_decay_rate);
      }
    if (strcmp(name, "time_step") == 0)
      {
	  return(time_step);
      }
   if (strcmp(name, "trial_length") == 0)
      {
	  return(trial_length);
      }
    if (strcmp(name, "lip_perturb_height") == 0)
      {
	  return(lip_perturb_height);
      }
    if (strcmp(name, "jaw_perturb_height") == 0)
      {
	  return(jaw_perturb_height);
      }
    if (strcmp(name, "jaw_fixed_height") == 0)
      {
	  return(jaw_fixed_height);
      }
    if (strcmp(name, "num_velocity_trials") == 0)
      {
	  return(num_velocity_trials);
      }
    if (strcmp(name, "num_phoneme_trials") == 0)
      {
	  return(num_phoneme_trials);
      }
    if (strcmp(name, "min_cube_factor") == 0)
      {
	  return(min_cube_factor);
      }
    if (strcmp(name, "coartic_distance") == 0)
      {
	  return(coartic_distance);
      }
    if (strcmp(name, "scale") == 0)
      {
	  return(scale);
      }
    if (strcmp(name, "stop_after_phoneme") == 0)
      {
	  return(stop_after_phoneme);
      }
    if (strcmp(name, "babbling_graphics_on") == 0)
      {
	  return(babbling_graphics_on);
      }
    if (strcmp(name, "sound_on") == 0)
      {
	  return(sound_on);
      }
    printf("Parameter '%s' not found;  add it to the routine\n",name);
    printf("get_parameter() in parameters.c\n.");
    exit(0);
}

void set_parameter(char name[], double value)
{
    int found = 0;
 
    if (strcmp(name, "which_fmap") == 0)
      {
	  which_fmap = value;
	  found = 1;
      }
    if (strcmp(name, "phoneme_learning_rate") == 0)
      {
	  phoneme_learning_rate = value;
	  found = 1;
      }
    if (strcmp(name, "phoneme_decay_rate") == 0)
      {
	  phoneme_decay_rate = value;
	  found = 1;
      }
    if (strcmp(name, "velocity_learning_rate") == 0)
      {
	  velocity_learning_rate = value;
	  found = 1;
      }
    if (strcmp(name, "velocity_decay_rate") == 0)
      {
	  velocity_decay_rate = value;
	  found = 1;
      }
    if (strcmp(name, "time_step") == 0)
      {
	  time_step = value;
	  found = 1;
      }
   if (strcmp(name, "trial_length") == 0)
      {
	  trial_length = value;
	  found = 1;
      }
    if (strcmp(name, "lip_perturb_height") == 0)
      {
	  lip_perturb_height = value;
	  found = 1;
      }
    if (strcmp(name, "jaw_perturb_height") == 0)
      {
	  jaw_perturb_height = value;
	  found = 1;
      }
    if (strcmp(name, "jaw_fixed_height") == 0)
      {
	  jaw_fixed_height = value;
	  found = 1;
      }
    if (strcmp(name, "num_velocity_trials") == 0)
      {
	  num_velocity_trials = value;
	  found = 1;
      }
    if (strcmp(name, "num_phoneme_trials") == 0)
      {
	  num_phoneme_trials = value;
	  found = 1;
      }
    if (strcmp(name, "min_cube_factor") == 0)
      {
	  min_cube_factor = value;
	  found = 1;
      }
    if (strcmp(name, "coartic_distance") == 0)
      {
	  coartic_distance = value;
	  found = 1;
      }
    if (strcmp(name, "scale") == 0)
      {
	  scale = value;
	  found = 1;
      }
    if (strcmp(name, "stop_after_phoneme") == 0)
      {
	  stop_after_phoneme = value;
	  found = 1;
      }
    if (strcmp(name, "babbling_graphics_on") == 0)
      {
	  babbling_graphics_on = value;
	  found = 1;
      }
    if (strcmp(name, "sound_on") == 0)
      {
	  sound_on = value;
	  found = 1;
      }
    if (found == 0)
      {
	  printf("Parameter '%s' not found;  add it to the routine\n",name);
	  printf("set_parameter() in parameters.c\n.");
	  exit(0);
      }
}


