typedef struct
        {
        int numhyp ;
        int *numseg ;
        double *w ;
        double *v ;
        double *sig ;
        double *mu ;
        double *h ;
        double target ;
        double out ;
        double error ;
        
        } FMap ;

typedef struct
        {
        int numhyp ;
        int *numseg ;
        double *w ;
        double *v ;
        double *sig ;
        double *mu ;
        double *h ;

        } PMap ;
        
typedef struct
        {
        double alpha;
        int numhyp ;
        int *numseg ;
        double *w ;
        double *v ;
        double *sig ;
        double *mu ;
        double *h ;

        } BMap ;
        
typedef struct
        {
        FMap *M ;
        PMap *J ;
        BMap *B ;
        int numFMaps ;
        int numPMaps ;
        int numBMaps ;
        int numEpochs ;
        int numreach ;
        int numstep ;
        int MAXHYP ;
        int numin ;
        int numtarget ;
        double *in ;
        double *previn ;
        double *posn ;
        double *target ;
        double *prevtarget ;
        int numJin ;
        int numJout ;
        double *Jin ;
        double *avgJin ;
        double *Jout ;
        double *Jtarget ;
        double *Jerror ;
        double *rangemin ;
        double *rangemax ;
        double maxdiff ;
        double *range ;
        double *linfit ;
        double *c ;
        double scale[3] ;
        double *direct ;
        int epochs ;
        double stepsize ;
        double etaF ;
	double metaF ;
        double etaP ;
        double etaP_max ;
	double metaP ;
        double etaB ;
        double metaB ;
        double numsamp ;

        } rbf_struct ;

extern rbf_struct *P;

extern rbf_struct *CreateRbf();
extern void TrainRbf(rbf_struct);
extern void RbfInvMap(double *,double *,double *, rbf_struct *);
extern void RbfForMap(double *,double *, rbf_struct *);
extern void SaveWeights(FILE *,rbf_struct *);
extern void ReadWeights( FILE *,rbf_struct *);
extern void FreeRbf( rbf_struct *);
extern void NormVec( double *, int);
extern int ComputeError(rbf_struct *,double *,double *, int);
extern int PutBasis(rbf_struct *,double *) ;
extern void PrintBias(rbf_struct *,double *);
