/*
 *      SenSyn - Version 1.0
 *
 *      Copyright (c) 1991, 1992 by Sensimetrics Corporation
 *      All Rights Reserved.
 *
 */

/*  reson.h - resonator declarations
 *
 *  coded by Eric P. Carlson, based upon reson.c by A.W. Howitt
 *
 *  Modification History:
 *    22 Jul 1992	changed type Float back to float
 *    26 Sep 1991	added AdvanceAntiResonator and InterPolePair
 *    14 Nov 1991	changed type Float double
 */

typedef float Float;

typedef struct {
	struct { Float A, B, C; } Coef;
	struct { Float Z1, Z2; } State;
} Resonator;

extern void ClearResonator(Resonator *theResonator);
extern Float AdvanceResonator(Resonator *theResonator, Float input);
extern Float AdvanceAntiResonator(Resonator *theResonator, Float input);
extern void SetPolePair(Resonator *theResonator, int CF, int BW, int SF);
extern void InterPolePair(Resonator *theResonator, int CF, int BW, int SF);
extern void SetZeroPair(Resonator *theResonator, int CF, int BW, int SF);
